/* page-view.c generated by valac 0.46.0, the Vala compiler
 * generated from page-view.vala, do not modify */

/*
 * Copyright (C) 2009-2015 Canonical Ltd.
 * Author: Robert Ancell <robert.ancell@canonical.com>
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include <glib-object.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <string.h>
#include <stdlib.h>
#include <cairo.h>

typedef enum  {
	CROP_LOCATION_NONE = 0,
	CROP_LOCATION_MIDDLE,
	CROP_LOCATION_TOP,
	CROP_LOCATION_BOTTOM,
	CROP_LOCATION_LEFT,
	CROP_LOCATION_RIGHT,
	CROP_LOCATION_TOP_LEFT,
	CROP_LOCATION_TOP_RIGHT,
	CROP_LOCATION_BOTTOM_LEFT,
	CROP_LOCATION_BOTTOM_RIGHT
} CropLocation;

#define TYPE_CROP_LOCATION (crop_location_get_type ())

#define TYPE_PAGE_VIEW (page_view_get_type ())
#define PAGE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAGE_VIEW, PageView))
#define PAGE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAGE_VIEW, PageViewClass))
#define IS_PAGE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAGE_VIEW))
#define IS_PAGE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAGE_VIEW))
#define PAGE_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAGE_VIEW, PageViewClass))

typedef struct _PageView PageView;
typedef struct _PageViewClass PageViewClass;
typedef struct _PageViewPrivate PageViewPrivate;

#define TYPE_PAGE (page_get_type ())
#define PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAGE, Page))
#define PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAGE, PageClass))
#define IS_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAGE))
#define IS_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAGE))
#define PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAGE, PageClass))

typedef struct _Page Page;
typedef struct _PageClass PageClass;
typedef enum  {
	SCAN_DIRECTION_TOP_TO_BOTTOM,
	SCAN_DIRECTION_LEFT_TO_RIGHT,
	SCAN_DIRECTION_BOTTOM_TO_TOP,
	SCAN_DIRECTION_RIGHT_TO_LEFT
} ScanDirection;

#define TYPE_SCAN_DIRECTION (scan_direction_get_type ())
enum  {
	PAGE_VIEW_0_PROPERTY,
	PAGE_VIEW_PAGE_PROPERTY,
	PAGE_VIEW_SELECTED_PROPERTY,
	PAGE_VIEW_X_OFFSET_PROPERTY,
	PAGE_VIEW_Y_OFFSET_PROPERTY,
	PAGE_VIEW_CURSOR_PROPERTY,
	PAGE_VIEW_WIDTH_PROPERTY,
	PAGE_VIEW_HEIGHT_PROPERTY,
	PAGE_VIEW_NUM_PROPERTIES
};
static GParamSpec* page_view_properties[PAGE_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	PAGE_VIEW_SIZE_CHANGED_SIGNAL,
	PAGE_VIEW_CHANGED_SIGNAL,
	PAGE_VIEW_NUM_SIGNALS
};
static guint page_view_signals[PAGE_VIEW_NUM_SIGNALS] = {0};

struct _PageView {
	GObject parent_instance;
	PageViewPrivate * priv;
};

struct _PageViewClass {
	GObjectClass parent_class;
};

struct _PageViewPrivate {
	Page* _page;
	GdkPixbuf* image;
	gboolean selected_;
	gint border_width;
	gboolean update_image;
	ScanDirection scan_direction;
	gint scan_line;
	gint width_;
	gint height_;
	gint _x_offset;
	gint _y_offset;
	CropLocation crop_location;
	gdouble selected_crop_px;
	gdouble selected_crop_py;
	gint selected_crop_x;
	gint selected_crop_y;
	gint selected_crop_w;
	gint selected_crop_h;
	GdkCursorType _cursor;
	gint animate_n_segments;
	gint animate_segment;
	guint animate_timeout;
};

static gint PageView_private_offset;
static gpointer page_view_parent_class = NULL;

GType crop_location_get_type (void) G_GNUC_CONST;
GType page_view_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PageView, g_object_unref)
GType page_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Page, g_object_unref)
GType scan_direction_get_type (void) G_GNUC_CONST;
Page* page_view_get_page (PageView* self);
static void page_view_page_pixels_changed_cb (PageView* self,
                                       Page* p);
static void _page_view_page_pixels_changed_cb_page_pixels_changed (Page* _sender,
                                                            gpointer self);
static void page_view_page_size_changed_cb (PageView* self,
                                     Page* p);
static void _page_view_page_size_changed_cb_page_size_changed (Page* _sender,
                                                        gpointer self);
static void page_view_page_overlay_changed_cb (PageView* self,
                                        Page* p);
static void _page_view_page_overlay_changed_cb_page_crop_changed (Page* _sender,
                                                           gpointer self);
static void _page_view_page_overlay_changed_cb_page_scan_line_changed (Page* _sender,
                                                                gpointer self);
static void page_view_scan_direction_changed_cb (PageView* self,
                                          Page* p);
static void _page_view_scan_direction_changed_cb_page_scan_direction_changed (Page* _sender,
                                                                       gpointer self);
PageView* page_view_new (Page* page);
PageView* page_view_construct (GType object_type,
                               Page* page);
static void page_view_set_page (PageView* self,
                         Page* value);
static guchar page_view_get_sample (PageView* self,
                             guchar* pixels,
                             gint pixels_length1,
                             gint offset,
                             gint x,
                             gint depth,
                             gint sample);
static void page_view_get_pixel (PageView* self,
                          Page* page,
                          gint x,
                          gint y,
                          guchar* pixel,
                          gint pixel_length1);
ScanDirection page_get_scan_direction (Page* self);
gint page_get_scan_width (Page* self);
gint page_get_scan_height (Page* self);
gint page_get_depth (Page* self);
gint page_get_n_channels (Page* self);
guchar* page_get_pixels (Page* self,
                         gint* result_length1);
gint page_get_rowstride (Page* self);
static void page_view_set_pixel (PageView* self,
                          Page* page,
                          gdouble l,
                          gdouble r,
                          gdouble t,
                          gdouble b,
                          guchar* output,
                          gint output_length1,
                          gint offset);
static void page_view_update_preview (PageView* self,
                               Page* page,
                               GdkPixbuf* * output_image,
                               gint output_width,
                               gint output_height,
                               ScanDirection scan_direction,
                               gint old_scan_line,
                               gint scan_line);
gint page_get_width (Page* self);
gint page_get_height (Page* self);
gboolean page_get_has_data (Page* self);
static gint page_view_get_preview_width (PageView* self);
static gint page_view_get_preview_height (PageView* self);
static void page_view_update_page_view (PageView* self);
gint page_get_scan_line (Page* self);
static gint page_view_page_to_screen_x (PageView* self,
                                 gint x);
static gint page_view_page_to_screen_y (PageView* self,
                                 gint y);
static gint page_view_screen_to_page_x (PageView* self,
                                 gint x);
static gint page_view_screen_to_page_y (PageView* self,
                                 gint y);
static CropLocation page_view_get_crop_location (PageView* self,
                                          gint x,
                                          gint y);
gboolean page_get_has_crop (Page* self);
gint page_get_crop_x (Page* self);
gint page_get_crop_y (Page* self);
gint page_get_crop_width (Page* self);
gint page_get_crop_height (Page* self);
const gchar* page_get_crop_name (Page* self);
void page_view_button_press (PageView* self,
                             gint x,
                             gint y);
void page_view_motion (PageView* self,
                       gint x,
                       gint y);
static void page_view_set_cursor (PageView* self,
                           GdkCursorType value);
void page_move_crop (Page* self,
                     gint x,
                     gint y);
void page_set_custom_crop (Page* self,
                           gint width,
                           gint height);
void page_view_button_release (PageView* self,
                               gint x,
                               gint y);
static gboolean page_view_animation_cb (PageView* self);
static void page_view_update_animation (PageView* self);
gboolean page_get_is_scanning (Page* self);
static gboolean _page_view_animation_cb_gsource_func (gpointer self);
void page_view_render (PageView* self,
                       cairo_t* context);
gint page_view_get_x_offset (PageView* self);
gint page_view_get_y_offset (PageView* self);
gboolean page_view_get_selected (PageView* self);
void page_view_set_selected (PageView* self,
                             gboolean value);
void page_view_set_x_offset (PageView* self,
                             gint value);
void page_view_set_y_offset (PageView* self,
                             gint value);
GdkCursorType page_view_get_cursor (PageView* self);
gint page_view_get_width (PageView* self);
void page_view_set_width (PageView* self,
                          gint value);
gint page_view_get_height (PageView* self);
void page_view_set_height (PageView* self,
                           gint value);
static void page_view_finalize (GObject * obj);
static void _vala_page_view_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec);
static void _vala_page_view_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec);

GType
crop_location_get_type (void)
{
	static volatile gsize crop_location_type_id__volatile = 0;
	if (g_once_init_enter (&crop_location_type_id__volatile)) {
		static const GEnumValue values[] = {{CROP_LOCATION_NONE, "CROP_LOCATION_NONE", "none"}, {CROP_LOCATION_MIDDLE, "CROP_LOCATION_MIDDLE", "middle"}, {CROP_LOCATION_TOP, "CROP_LOCATION_TOP", "top"}, {CROP_LOCATION_BOTTOM, "CROP_LOCATION_BOTTOM", "bottom"}, {CROP_LOCATION_LEFT, "CROP_LOCATION_LEFT", "left"}, {CROP_LOCATION_RIGHT, "CROP_LOCATION_RIGHT", "right"}, {CROP_LOCATION_TOP_LEFT, "CROP_LOCATION_TOP_LEFT", "top-left"}, {CROP_LOCATION_TOP_RIGHT, "CROP_LOCATION_TOP_RIGHT", "top-right"}, {CROP_LOCATION_BOTTOM_LEFT, "CROP_LOCATION_BOTTOM_LEFT", "bottom-left"}, {CROP_LOCATION_BOTTOM_RIGHT, "CROP_LOCATION_BOTTOM_RIGHT", "bottom-right"}, {0, NULL, NULL}};
		GType crop_location_type_id;
		crop_location_type_id = g_enum_register_static ("CropLocation", values);
		g_once_init_leave (&crop_location_type_id__volatile, crop_location_type_id);
	}
	return crop_location_type_id__volatile;
}

static inline gpointer
page_view_get_instance_private (PageView* self)
{
	return G_STRUCT_MEMBER_P (self, PageView_private_offset);
}

static void
_page_view_page_pixels_changed_cb_page_pixels_changed (Page* _sender,
                                                       gpointer self)
{
#line 97 "../src/page-view.vala"
	page_view_page_pixels_changed_cb ((PageView*) self, _sender);
#line 293 "page-view.c"
}

static void
_page_view_page_size_changed_cb_page_size_changed (Page* _sender,
                                                   gpointer self)
{
#line 98 "../src/page-view.vala"
	page_view_page_size_changed_cb ((PageView*) self, _sender);
#line 302 "page-view.c"
}

static void
_page_view_page_overlay_changed_cb_page_crop_changed (Page* _sender,
                                                      gpointer self)
{
#line 99 "../src/page-view.vala"
	page_view_page_overlay_changed_cb ((PageView*) self, _sender);
#line 311 "page-view.c"
}

static void
_page_view_page_overlay_changed_cb_page_scan_line_changed (Page* _sender,
                                                           gpointer self)
{
#line 100 "../src/page-view.vala"
	page_view_page_overlay_changed_cb ((PageView*) self, _sender);
#line 320 "page-view.c"
}

static void
_page_view_scan_direction_changed_cb_page_scan_direction_changed (Page* _sender,
                                                                  gpointer self)
{
#line 101 "../src/page-view.vala"
	page_view_scan_direction_changed_cb ((PageView*) self, _sender);
#line 329 "page-view.c"
}

PageView*
page_view_construct (GType object_type,
                     Page* page)
{
	PageView * self = NULL;
#line 85 "../src/page-view.vala"
	g_return_val_if_fail (page != NULL, NULL);
#line 85 "../src/page-view.vala"
	self = (PageView*) g_object_new (object_type, NULL);
#line 87 "../src/page-view.vala"
	page_view_set_page (self, page);
#line 88 "../src/page-view.vala"
	g_signal_connect_object (page, "pixels-changed", (GCallback) _page_view_page_pixels_changed_cb_page_pixels_changed, self, 0);
#line 89 "../src/page-view.vala"
	g_signal_connect_object (page, "size-changed", (GCallback) _page_view_page_size_changed_cb_page_size_changed, self, 0);
#line 90 "../src/page-view.vala"
	g_signal_connect_object (page, "crop-changed", (GCallback) _page_view_page_overlay_changed_cb_page_crop_changed, self, 0);
#line 91 "../src/page-view.vala"
	g_signal_connect_object (page, "scan-line-changed", (GCallback) _page_view_page_overlay_changed_cb_page_scan_line_changed, self, 0);
#line 92 "../src/page-view.vala"
	g_signal_connect_object (page, "scan-direction-changed", (GCallback) _page_view_scan_direction_changed_cb_page_scan_direction_changed, self, 0);
#line 85 "../src/page-view.vala"
	return self;
#line 355 "page-view.c"
}

PageView*
page_view_new (Page* page)
{
#line 85 "../src/page-view.vala"
	return page_view_construct (TYPE_PAGE_VIEW, page);
#line 363 "page-view.c"
}

static guchar
page_view_get_sample (PageView* self,
                      guchar* pixels,
                      gint pixels_length1,
                      gint offset,
                      gint x,
                      gint depth,
                      gint sample)
{
	guchar result = '\0';
#line 104 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, '\0');
#line 107 "../src/page-view.vala"
	result = (guchar) 0xFF;
#line 107 "../src/page-view.vala"
	return result;
#line 382 "page-view.c"
}

static void
page_view_get_pixel (PageView* self,
                     Page* page,
                     gint x,
                     gint y,
                     guchar* pixel,
                     gint pixel_length1)
{
	ScanDirection _tmp0_;
	ScanDirection _tmp1_;
	gint depth = 0;
	gint _tmp10_;
	gint _tmp11_;
	gint n_channels = 0;
	gint _tmp12_;
	gint _tmp13_;
	guchar* pixels = NULL;
	gint _tmp14_ = 0;
	guchar* _tmp15_;
	gint pixels_length1;
	gint _pixels_size_;
	gint offset = 0;
	gint _tmp16_;
	gint _tmp17_;
	gboolean _tmp18_ = FALSE;
	guchar* _tmp37_;
	gint _tmp37__length1;
	guchar* _tmp38_;
	gint _tmp38__length1;
	guchar* _tmp39_;
	gint _tmp39__length1;
#line 110 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 110 "../src/page-view.vala"
	g_return_if_fail (page != NULL);
#line 112 "../src/page-view.vala"
	_tmp0_ = page_get_scan_direction (page);
#line 112 "../src/page-view.vala"
	_tmp1_ = _tmp0_;
#line 112 "../src/page-view.vala"
	switch (_tmp1_) {
#line 112 "../src/page-view.vala"
		case SCAN_DIRECTION_TOP_TO_BOTTOM:
#line 428 "page-view.c"
		{
#line 115 "../src/page-view.vala"
			break;
#line 432 "page-view.c"
		}
#line 112 "../src/page-view.vala"
		case SCAN_DIRECTION_BOTTOM_TO_TOP:
#line 436 "page-view.c"
		{
			gint _tmp2_;
			gint _tmp3_;
			gint _tmp4_;
			gint _tmp5_;
#line 117 "../src/page-view.vala"
			_tmp2_ = page_get_scan_width (page);
#line 117 "../src/page-view.vala"
			_tmp3_ = _tmp2_;
#line 117 "../src/page-view.vala"
			x = (_tmp3_ - x) - 1;
#line 118 "../src/page-view.vala"
			_tmp4_ = page_get_scan_height (page);
#line 118 "../src/page-view.vala"
			_tmp5_ = _tmp4_;
#line 118 "../src/page-view.vala"
			y = (_tmp5_ - y) - 1;
#line 119 "../src/page-view.vala"
			break;
#line 456 "page-view.c"
		}
#line 112 "../src/page-view.vala"
		case SCAN_DIRECTION_LEFT_TO_RIGHT:
#line 460 "page-view.c"
		{
			gint t = 0;
			gint _tmp6_;
			gint _tmp7_;
#line 121 "../src/page-view.vala"
			t = x;
#line 122 "../src/page-view.vala"
			_tmp6_ = page_get_scan_width (page);
#line 122 "../src/page-view.vala"
			_tmp7_ = _tmp6_;
#line 122 "../src/page-view.vala"
			x = (_tmp7_ - y) - 1;
#line 123 "../src/page-view.vala"
			y = t;
#line 124 "../src/page-view.vala"
			break;
#line 477 "page-view.c"
		}
#line 112 "../src/page-view.vala"
		case SCAN_DIRECTION_RIGHT_TO_LEFT:
#line 481 "page-view.c"
		{
			gint t = 0;
			gint _tmp8_;
			gint _tmp9_;
#line 126 "../src/page-view.vala"
			t = x;
#line 127 "../src/page-view.vala"
			x = y;
#line 128 "../src/page-view.vala"
			_tmp8_ = page_get_scan_height (page);
#line 128 "../src/page-view.vala"
			_tmp9_ = _tmp8_;
#line 128 "../src/page-view.vala"
			y = (_tmp9_ - t) - 1;
#line 129 "../src/page-view.vala"
			break;
#line 498 "page-view.c"
		}
		default:
#line 112 "../src/page-view.vala"
		break;
#line 503 "page-view.c"
	}
#line 132 "../src/page-view.vala"
	_tmp10_ = page_get_depth (page);
#line 132 "../src/page-view.vala"
	_tmp11_ = _tmp10_;
#line 132 "../src/page-view.vala"
	depth = _tmp11_;
#line 133 "../src/page-view.vala"
	_tmp12_ = page_get_n_channels (page);
#line 133 "../src/page-view.vala"
	_tmp13_ = _tmp12_;
#line 133 "../src/page-view.vala"
	n_channels = _tmp13_;
#line 134 "../src/page-view.vala"
	_tmp15_ = page_get_pixels (page, &_tmp14_);
#line 134 "../src/page-view.vala"
	pixels = _tmp15_;
#line 134 "../src/page-view.vala"
	pixels_length1 = _tmp14_;
#line 134 "../src/page-view.vala"
	_pixels_size_ = pixels_length1;
#line 135 "../src/page-view.vala"
	_tmp16_ = page_get_rowstride (page);
#line 135 "../src/page-view.vala"
	_tmp17_ = _tmp16_;
#line 135 "../src/page-view.vala"
	offset = _tmp17_ * y;
#line 138 "../src/page-view.vala"
	if (depth == 8) {
#line 138 "../src/page-view.vala"
		_tmp18_ = n_channels == 3;
#line 535 "page-view.c"
	} else {
#line 138 "../src/page-view.vala"
		_tmp18_ = FALSE;
#line 539 "page-view.c"
	}
#line 138 "../src/page-view.vala"
	if (_tmp18_) {
#line 543 "page-view.c"
		gint o = 0;
		guchar* _tmp19_;
		gint _tmp19__length1;
		guchar _tmp20_;
		guchar* _tmp21_;
		gint _tmp21__length1;
		guchar _tmp22_;
		guchar* _tmp23_;
		gint _tmp23__length1;
		guchar _tmp24_;
#line 140 "../src/page-view.vala"
		o = offset + (x * n_channels);
#line 141 "../src/page-view.vala"
		_tmp19_ = pixels;
#line 141 "../src/page-view.vala"
		_tmp19__length1 = pixels_length1;
#line 141 "../src/page-view.vala"
		_tmp20_ = _tmp19_[o];
#line 141 "../src/page-view.vala"
		pixel[0] = _tmp20_;
#line 142 "../src/page-view.vala"
		_tmp21_ = pixels;
#line 142 "../src/page-view.vala"
		_tmp21__length1 = pixels_length1;
#line 142 "../src/page-view.vala"
		_tmp22_ = _tmp21_[o + 1];
#line 142 "../src/page-view.vala"
		pixel[1] = _tmp22_;
#line 143 "../src/page-view.vala"
		_tmp23_ = pixels;
#line 143 "../src/page-view.vala"
		_tmp23__length1 = pixels_length1;
#line 143 "../src/page-view.vala"
		_tmp24_ = _tmp23_[o + 2];
#line 143 "../src/page-view.vala"
		pixel[2] = _tmp24_;
#line 144 "../src/page-view.vala"
		return;
#line 582 "page-view.c"
	} else {
		gboolean _tmp25_ = FALSE;
#line 146 "../src/page-view.vala"
		if (depth == 8) {
#line 146 "../src/page-view.vala"
			_tmp25_ = n_channels == 1;
#line 589 "page-view.c"
		} else {
#line 146 "../src/page-view.vala"
			_tmp25_ = FALSE;
#line 593 "page-view.c"
		}
#line 146 "../src/page-view.vala"
		if (_tmp25_) {
#line 597 "page-view.c"
			guchar* _tmp26_;
			gint _tmp26__length1;
			guchar _tmp27_;
#line 148 "../src/page-view.vala"
			_tmp26_ = pixels;
#line 148 "../src/page-view.vala"
			_tmp26__length1 = pixels_length1;
#line 148 "../src/page-view.vala"
			_tmp27_ = _tmp26_[offset + x];
#line 148 "../src/page-view.vala"
			pixel[2] = _tmp27_;
#line 148 "../src/page-view.vala"
			pixel[1] = _tmp27_;
#line 148 "../src/page-view.vala"
			pixel[0] = _tmp27_;
#line 149 "../src/page-view.vala"
			return;
#line 615 "page-view.c"
		} else {
			gboolean _tmp28_ = FALSE;
#line 153 "../src/page-view.vala"
			if (depth == 1) {
#line 153 "../src/page-view.vala"
				_tmp28_ = n_channels == 1;
#line 622 "page-view.c"
			} else {
#line 153 "../src/page-view.vala"
				_tmp28_ = FALSE;
#line 626 "page-view.c"
			}
#line 153 "../src/page-view.vala"
			if (_tmp28_) {
#line 630 "page-view.c"
				gint o = 0;
				gint _tmp29_ = 0;
				guchar* _tmp30_;
				gint _tmp30__length1;
				guchar _tmp31_;
#line 155 "../src/page-view.vala"
				o = offset + (x / 8);
#line 156 "../src/page-view.vala"
				_tmp30_ = pixels;
#line 156 "../src/page-view.vala"
				_tmp30__length1 = pixels_length1;
#line 156 "../src/page-view.vala"
				_tmp31_ = _tmp30_[o];
#line 156 "../src/page-view.vala"
				if (((gint) (_tmp31_ & (0x80 >> (x % 8)))) != 0) {
#line 156 "../src/page-view.vala"
					_tmp29_ = 0x00;
#line 648 "page-view.c"
				} else {
#line 156 "../src/page-view.vala"
					_tmp29_ = 0xFF;
#line 652 "page-view.c"
				}
#line 156 "../src/page-view.vala"
				pixel[2] = (guchar) _tmp29_;
#line 156 "../src/page-view.vala"
				pixel[1] = (guchar) _tmp29_;
#line 156 "../src/page-view.vala"
				pixel[0] = (guchar) _tmp29_;
#line 157 "../src/page-view.vala"
				return;
#line 662 "page-view.c"
			} else {
				gboolean _tmp32_ = FALSE;
#line 161 "../src/page-view.vala"
				if (depth == 2) {
#line 161 "../src/page-view.vala"
					_tmp32_ = n_channels == 1;
#line 669 "page-view.c"
				} else {
#line 161 "../src/page-view.vala"
					_tmp32_ = FALSE;
#line 673 "page-view.c"
				}
#line 161 "../src/page-view.vala"
				if (_tmp32_) {
#line 677 "page-view.c"
					gint block_shift[4] = {0};
					gint _tmp33_[4] = {0};
					gint o = 0;
					gint sample = 0;
					guchar* _tmp34_;
					gint _tmp34__length1;
					guchar _tmp35_;
					gint _tmp36_;
#line 163 "../src/page-view.vala"
					_tmp33_[0] = 6;
#line 163 "../src/page-view.vala"
					_tmp33_[1] = 4;
#line 163 "../src/page-view.vala"
					_tmp33_[2] = 2;
#line 163 "../src/page-view.vala"
					_tmp33_[3] = 0;
#line 163 "../src/page-view.vala"
					memcpy (block_shift, _tmp33_, 4 * sizeof (gint));
#line 165 "../src/page-view.vala"
					o = offset + (x / 4);
#line 166 "../src/page-view.vala"
					_tmp34_ = pixels;
#line 166 "../src/page-view.vala"
					_tmp34__length1 = pixels_length1;
#line 166 "../src/page-view.vala"
					_tmp35_ = _tmp34_[o];
#line 166 "../src/page-view.vala"
					_tmp36_ = block_shift[x % 4];
#line 166 "../src/page-view.vala"
					sample = (_tmp35_ >> _tmp36_) & 0x3;
#line 167 "../src/page-view.vala"
					sample = (sample * 255) / 3;
#line 169 "../src/page-view.vala"
					pixel[2] = (guchar) sample;
#line 169 "../src/page-view.vala"
					pixel[1] = (guchar) sample;
#line 169 "../src/page-view.vala"
					pixel[0] = (guchar) sample;
#line 170 "../src/page-view.vala"
					return;
#line 718 "page-view.c"
				}
			}
		}
	}
#line 174 "../src/page-view.vala"
	_tmp37_ = pixels;
#line 174 "../src/page-view.vala"
	_tmp37__length1 = pixels_length1;
#line 174 "../src/page-view.vala"
	pixel[0] = page_view_get_sample (self, _tmp37_, (gint) _tmp37__length1, offset, x, depth, x * n_channels);
#line 175 "../src/page-view.vala"
	_tmp38_ = pixels;
#line 175 "../src/page-view.vala"
	_tmp38__length1 = pixels_length1;
#line 175 "../src/page-view.vala"
	pixel[1] = page_view_get_sample (self, _tmp38_, (gint) _tmp38__length1, offset, x, depth, (x * n_channels) + 1);
#line 176 "../src/page-view.vala"
	_tmp39_ = pixels;
#line 176 "../src/page-view.vala"
	_tmp39__length1 = pixels_length1;
#line 176 "../src/page-view.vala"
	pixel[2] = page_view_get_sample (self, _tmp39_, (gint) _tmp39__length1, offset, x, depth, (x * n_channels) + 2);
#line 741 "page-view.c"
}

static void
page_view_set_pixel (PageView* self,
                     Page* page,
                     gdouble l,
                     gdouble r,
                     gdouble t,
                     gdouble b,
                     guchar* output,
                     gint output_length1,
                     gint offset)
{
	gint L = 0;
	gint R = 0;
	gint T = 0;
	gint B = 0;
	gdouble red = 0.0;
	gdouble green = 0.0;
	gdouble blue = 0.0;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp54_ = FALSE;
	gboolean _tmp58_ = FALSE;
	gboolean _tmp62_ = FALSE;
	gboolean _tmp66_ = FALSE;
	gdouble scale = 0.0;
#line 179 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 179 "../src/page-view.vala"
	g_return_if_fail (page != NULL);
#line 225 "../src/page-view.vala"
	L = (gint) l;
#line 226 "../src/page-view.vala"
	if (((gdouble) L) != l) {
#line 777 "page-view.c"
		gint _tmp0_;
#line 227 "../src/page-view.vala"
		_tmp0_ = L;
#line 227 "../src/page-view.vala"
		L = _tmp0_ + 1;
#line 783 "page-view.c"
	}
#line 228 "../src/page-view.vala"
	R = (gint) r;
#line 229 "../src/page-view.vala"
	T = (gint) t;
#line 230 "../src/page-view.vala"
	if (((gdouble) T) != t) {
#line 791 "page-view.c"
		gint _tmp1_;
#line 231 "../src/page-view.vala"
		_tmp1_ = T;
#line 231 "../src/page-view.vala"
		T = _tmp1_ + 1;
#line 797 "page-view.c"
	}
#line 232 "../src/page-view.vala"
	B = (gint) b;
#line 234 "../src/page-view.vala"
	red = 0.0;
#line 235 "../src/page-view.vala"
	green = 0.0;
#line 236 "../src/page-view.vala"
	blue = 0.0;
#line 247 "../src/page-view.vala"
	if ((r - l) <= 1.0) {
#line 247 "../src/page-view.vala"
		_tmp3_ = ((gint) r) == ((gint) l);
#line 811 "page-view.c"
	} else {
#line 247 "../src/page-view.vala"
		_tmp3_ = FALSE;
#line 815 "page-view.c"
	}
#line 247 "../src/page-view.vala"
	if (_tmp3_) {
#line 247 "../src/page-view.vala"
		_tmp2_ = TRUE;
#line 821 "page-view.c"
	} else {
		gboolean _tmp4_ = FALSE;
#line 247 "../src/page-view.vala"
		if ((b - t) <= 1.0) {
#line 247 "../src/page-view.vala"
			_tmp4_ = ((gint) b) == ((gint) t);
#line 828 "page-view.c"
		} else {
#line 247 "../src/page-view.vala"
			_tmp4_ = FALSE;
#line 832 "page-view.c"
		}
#line 247 "../src/page-view.vala"
		_tmp2_ = _tmp4_;
#line 836 "page-view.c"
	}
#line 247 "../src/page-view.vala"
	if (_tmp2_) {
#line 840 "page-view.c"
		gboolean _tmp5_ = FALSE;
		gdouble scale = 0.0;
#line 250 "../src/page-view.vala"
		if (((gint) l) == ((gint) r)) {
#line 250 "../src/page-view.vala"
			_tmp5_ = TRUE;
#line 847 "page-view.c"
		} else {
#line 250 "../src/page-view.vala"
			_tmp5_ = ((gint) t) == ((gint) b);
#line 851 "page-view.c"
		}
#line 250 "../src/page-view.vala"
		if (_tmp5_) {
#line 855 "page-view.c"
			guchar p[3] = {0};
			guchar _tmp6_;
			guchar _tmp7_;
			guchar _tmp8_;
#line 253 "../src/page-view.vala"
			page_view_get_pixel (self, page, (gint) l, (gint) t, p, (gint) 3);
#line 254 "../src/page-view.vala"
			_tmp6_ = p[0];
#line 254 "../src/page-view.vala"
			output[offset] = _tmp6_;
#line 255 "../src/page-view.vala"
			_tmp7_ = p[1];
#line 255 "../src/page-view.vala"
			output[offset + 1] = _tmp7_;
#line 256 "../src/page-view.vala"
			_tmp8_ = p[2];
#line 256 "../src/page-view.vala"
			output[offset + 2] = _tmp8_;
#line 257 "../src/page-view.vala"
			return;
#line 876 "page-view.c"
		}
#line 261 "../src/page-view.vala"
		if (L > R) {
#line 880 "page-view.c"
			guchar p[3] = {0};
			guchar _tmp9_;
			guchar _tmp10_;
			guchar _tmp11_;
			guchar _tmp17_;
			guchar _tmp18_;
			guchar _tmp19_;
#line 264 "../src/page-view.vala"
			page_view_get_pixel (self, page, R, T - 1, p, (gint) 3);
#line 265 "../src/page-view.vala"
			_tmp9_ = p[0];
#line 265 "../src/page-view.vala"
			red += (_tmp9_ * (r - l)) * (T - t);
#line 266 "../src/page-view.vala"
			_tmp10_ = p[1];
#line 266 "../src/page-view.vala"
			green += (_tmp10_ * (r - l)) * (T - t);
#line 267 "../src/page-view.vala"
			_tmp11_ = p[2];
#line 267 "../src/page-view.vala"
			blue += (_tmp11_ * (r - l)) * (T - t);
#line 902 "page-view.c"
			{
				gint y = 0;
#line 268 "../src/page-view.vala"
				y = T;
#line 907 "page-view.c"
				{
					gboolean _tmp12_ = FALSE;
#line 268 "../src/page-view.vala"
					_tmp12_ = TRUE;
#line 268 "../src/page-view.vala"
					while (TRUE) {
#line 914 "page-view.c"
						guchar _tmp14_;
						guchar _tmp15_;
						guchar _tmp16_;
#line 268 "../src/page-view.vala"
						if (!_tmp12_) {
#line 920 "page-view.c"
							gint _tmp13_;
#line 268 "../src/page-view.vala"
							_tmp13_ = y;
#line 268 "../src/page-view.vala"
							y = _tmp13_ + 1;
#line 926 "page-view.c"
						}
#line 268 "../src/page-view.vala"
						_tmp12_ = FALSE;
#line 268 "../src/page-view.vala"
						if (!(y < B)) {
#line 268 "../src/page-view.vala"
							break;
#line 934 "page-view.c"
						}
#line 270 "../src/page-view.vala"
						page_view_get_pixel (self, page, R, y, p, (gint) 3);
#line 271 "../src/page-view.vala"
						_tmp14_ = p[0];
#line 271 "../src/page-view.vala"
						red += _tmp14_ * (r - l);
#line 272 "../src/page-view.vala"
						_tmp15_ = p[1];
#line 272 "../src/page-view.vala"
						green += _tmp15_ * (r - l);
#line 273 "../src/page-view.vala"
						_tmp16_ = p[2];
#line 273 "../src/page-view.vala"
						blue += _tmp16_ * (r - l);
#line 950 "page-view.c"
					}
				}
			}
#line 275 "../src/page-view.vala"
			page_view_get_pixel (self, page, R, B, p, (gint) 3);
#line 276 "../src/page-view.vala"
			_tmp17_ = p[0];
#line 276 "../src/page-view.vala"
			red += (_tmp17_ * (r - l)) * (b - B);
#line 277 "../src/page-view.vala"
			_tmp18_ = p[1];
#line 277 "../src/page-view.vala"
			green += (_tmp18_ * (r - l)) * (b - B);
#line 278 "../src/page-view.vala"
			_tmp19_ = p[2];
#line 278 "../src/page-view.vala"
			blue += (_tmp19_ * (r - l)) * (b - B);
#line 968 "page-view.c"
		} else {
			guchar p[3] = {0};
			guchar _tmp20_;
			guchar _tmp21_;
			guchar _tmp22_;
			guchar _tmp28_;
			guchar _tmp29_;
			guchar _tmp30_;
#line 284 "../src/page-view.vala"
			page_view_get_pixel (self, page, L - 1, B, p, (gint) 3);
#line 285 "../src/page-view.vala"
			_tmp20_ = p[0];
#line 285 "../src/page-view.vala"
			red += (_tmp20_ * (b - t)) * (L - l);
#line 286 "../src/page-view.vala"
			_tmp21_ = p[1];
#line 286 "../src/page-view.vala"
			green += (_tmp21_ * (b - t)) * (L - l);
#line 287 "../src/page-view.vala"
			_tmp22_ = p[2];
#line 287 "../src/page-view.vala"
			blue += (_tmp22_ * (b - t)) * (L - l);
#line 991 "page-view.c"
			{
				gint x = 0;
#line 288 "../src/page-view.vala"
				x = L;
#line 996 "page-view.c"
				{
					gboolean _tmp23_ = FALSE;
#line 288 "../src/page-view.vala"
					_tmp23_ = TRUE;
#line 288 "../src/page-view.vala"
					while (TRUE) {
#line 1003 "page-view.c"
						guchar _tmp25_;
						guchar _tmp26_;
						guchar _tmp27_;
#line 288 "../src/page-view.vala"
						if (!_tmp23_) {
#line 1009 "page-view.c"
							gint _tmp24_;
#line 288 "../src/page-view.vala"
							_tmp24_ = x;
#line 288 "../src/page-view.vala"
							x = _tmp24_ + 1;
#line 1015 "page-view.c"
						}
#line 288 "../src/page-view.vala"
						_tmp23_ = FALSE;
#line 288 "../src/page-view.vala"
						if (!(x < R)) {
#line 288 "../src/page-view.vala"
							break;
#line 1023 "page-view.c"
						}
#line 289 "../src/page-view.vala"
						page_view_get_pixel (self, page, x, B, p, (gint) 3);
#line 290 "../src/page-view.vala"
						_tmp25_ = p[0];
#line 290 "../src/page-view.vala"
						red += _tmp25_ * (b - t);
#line 291 "../src/page-view.vala"
						_tmp26_ = p[1];
#line 291 "../src/page-view.vala"
						green += _tmp26_ * (b - t);
#line 292 "../src/page-view.vala"
						_tmp27_ = p[2];
#line 292 "../src/page-view.vala"
						blue += _tmp27_ * (b - t);
#line 1039 "page-view.c"
					}
				}
			}
#line 294 "../src/page-view.vala"
			page_view_get_pixel (self, page, R, B, p, (gint) 3);
#line 295 "../src/page-view.vala"
			_tmp28_ = p[0];
#line 295 "../src/page-view.vala"
			red += (_tmp28_ * (b - t)) * (r - R);
#line 296 "../src/page-view.vala"
			_tmp29_ = p[1];
#line 296 "../src/page-view.vala"
			green += (_tmp29_ * (b - t)) * (r - R);
#line 297 "../src/page-view.vala"
			_tmp30_ = p[2];
#line 297 "../src/page-view.vala"
			blue += (_tmp30_ * (b - t)) * (r - R);
#line 1057 "page-view.c"
		}
#line 300 "../src/page-view.vala"
		scale = 1.0 / ((r - l) * (b - t));
#line 301 "../src/page-view.vala"
		output[offset] = (guchar) ((red * scale) + 0.5);
#line 302 "../src/page-view.vala"
		output[offset + 1] = (guchar) ((green * scale) + 0.5);
#line 303 "../src/page-view.vala"
		output[offset + 2] = (guchar) ((blue * scale) + 0.5);
#line 304 "../src/page-view.vala"
		return;
#line 1069 "page-view.c"
	}
	{
		gint x = 0;
#line 308 "../src/page-view.vala"
		x = L;
#line 1075 "page-view.c"
		{
			gboolean _tmp31_ = FALSE;
#line 308 "../src/page-view.vala"
			_tmp31_ = TRUE;
#line 308 "../src/page-view.vala"
			while (TRUE) {
#line 308 "../src/page-view.vala"
				if (!_tmp31_) {
#line 1084 "page-view.c"
					gint _tmp32_;
#line 308 "../src/page-view.vala"
					_tmp32_ = x;
#line 308 "../src/page-view.vala"
					x = _tmp32_ + 1;
#line 1090 "page-view.c"
				}
#line 308 "../src/page-view.vala"
				_tmp31_ = FALSE;
#line 308 "../src/page-view.vala"
				if (!(x < R)) {
#line 308 "../src/page-view.vala"
					break;
#line 1098 "page-view.c"
				}
				{
					gint y = 0;
#line 310 "../src/page-view.vala"
					y = T;
#line 1104 "page-view.c"
					{
						gboolean _tmp33_ = FALSE;
#line 310 "../src/page-view.vala"
						_tmp33_ = TRUE;
#line 310 "../src/page-view.vala"
						while (TRUE) {
#line 1111 "page-view.c"
							guchar p[3] = {0};
							guchar _tmp35_;
							guchar _tmp36_;
							guchar _tmp37_;
#line 310 "../src/page-view.vala"
							if (!_tmp33_) {
#line 1118 "page-view.c"
								gint _tmp34_;
#line 310 "../src/page-view.vala"
								_tmp34_ = y;
#line 310 "../src/page-view.vala"
								y = _tmp34_ + 1;
#line 1124 "page-view.c"
							}
#line 310 "../src/page-view.vala"
							_tmp33_ = FALSE;
#line 310 "../src/page-view.vala"
							if (!(y < B)) {
#line 310 "../src/page-view.vala"
								break;
#line 1132 "page-view.c"
							}
#line 313 "../src/page-view.vala"
							page_view_get_pixel (self, page, x, y, p, (gint) 3);
#line 314 "../src/page-view.vala"
							_tmp35_ = p[0];
#line 314 "../src/page-view.vala"
							red += (gdouble) _tmp35_;
#line 315 "../src/page-view.vala"
							_tmp36_ = p[1];
#line 315 "../src/page-view.vala"
							green += (gdouble) _tmp36_;
#line 316 "../src/page-view.vala"
							_tmp37_ = p[2];
#line 316 "../src/page-view.vala"
							blue += (gdouble) _tmp37_;
#line 1148 "page-view.c"
						}
					}
				}
			}
		}
	}
	{
		gint x = 0;
#line 321 "../src/page-view.vala"
		x = L;
#line 1159 "page-view.c"
		{
			gboolean _tmp38_ = FALSE;
#line 321 "../src/page-view.vala"
			_tmp38_ = TRUE;
#line 321 "../src/page-view.vala"
			while (TRUE) {
#line 321 "../src/page-view.vala"
				if (!_tmp38_) {
#line 1168 "page-view.c"
					gint _tmp39_;
#line 321 "../src/page-view.vala"
					_tmp39_ = x;
#line 321 "../src/page-view.vala"
					x = _tmp39_ + 1;
#line 1174 "page-view.c"
				}
#line 321 "../src/page-view.vala"
				_tmp38_ = FALSE;
#line 321 "../src/page-view.vala"
				if (!(x < R)) {
#line 321 "../src/page-view.vala"
					break;
#line 1182 "page-view.c"
				}
#line 323 "../src/page-view.vala"
				if (t != ((gdouble) T)) {
#line 1186 "page-view.c"
					guchar p[3] = {0};
					guchar _tmp40_;
					guchar _tmp41_;
					guchar _tmp42_;
#line 326 "../src/page-view.vala"
					page_view_get_pixel (self, page, x, T - 1, p, (gint) 3);
#line 327 "../src/page-view.vala"
					_tmp40_ = p[0];
#line 327 "../src/page-view.vala"
					red += _tmp40_ * (T - t);
#line 328 "../src/page-view.vala"
					_tmp41_ = p[1];
#line 328 "../src/page-view.vala"
					green += _tmp41_ * (T - t);
#line 329 "../src/page-view.vala"
					_tmp42_ = p[2];
#line 329 "../src/page-view.vala"
					blue += _tmp42_ * (T - t);
#line 1205 "page-view.c"
				}
#line 332 "../src/page-view.vala"
				if (b != ((gdouble) B)) {
#line 1209 "page-view.c"
					guchar p[3] = {0};
					guchar _tmp43_;
					guchar _tmp44_;
					guchar _tmp45_;
#line 335 "../src/page-view.vala"
					page_view_get_pixel (self, page, x, B, p, (gint) 3);
#line 336 "../src/page-view.vala"
					_tmp43_ = p[0];
#line 336 "../src/page-view.vala"
					red += _tmp43_ * (b - B);
#line 337 "../src/page-view.vala"
					_tmp44_ = p[1];
#line 337 "../src/page-view.vala"
					green += _tmp44_ * (b - B);
#line 338 "../src/page-view.vala"
					_tmp45_ = p[2];
#line 338 "../src/page-view.vala"
					blue += _tmp45_ * (b - B);
#line 1228 "page-view.c"
				}
			}
		}
	}
	{
		gint y = 0;
#line 343 "../src/page-view.vala"
		y = T;
#line 1237 "page-view.c"
		{
			gboolean _tmp46_ = FALSE;
#line 343 "../src/page-view.vala"
			_tmp46_ = TRUE;
#line 343 "../src/page-view.vala"
			while (TRUE) {
#line 343 "../src/page-view.vala"
				if (!_tmp46_) {
#line 1246 "page-view.c"
					gint _tmp47_;
#line 343 "../src/page-view.vala"
					_tmp47_ = y;
#line 343 "../src/page-view.vala"
					y = _tmp47_ + 1;
#line 1252 "page-view.c"
				}
#line 343 "../src/page-view.vala"
				_tmp46_ = FALSE;
#line 343 "../src/page-view.vala"
				if (!(y < B)) {
#line 343 "../src/page-view.vala"
					break;
#line 1260 "page-view.c"
				}
#line 345 "../src/page-view.vala"
				if (l != ((gdouble) L)) {
#line 1264 "page-view.c"
					guchar p[3] = {0};
					guchar _tmp48_;
					guchar _tmp49_;
					guchar _tmp50_;
#line 348 "../src/page-view.vala"
					page_view_get_pixel (self, page, L - 1, y, p, (gint) 3);
#line 349 "../src/page-view.vala"
					_tmp48_ = p[0];
#line 349 "../src/page-view.vala"
					red += _tmp48_ * (L - l);
#line 350 "../src/page-view.vala"
					_tmp49_ = p[1];
#line 350 "../src/page-view.vala"
					green += _tmp49_ * (L - l);
#line 351 "../src/page-view.vala"
					_tmp50_ = p[2];
#line 351 "../src/page-view.vala"
					blue += _tmp50_ * (L - l);
#line 1283 "page-view.c"
				}
#line 354 "../src/page-view.vala"
				if (r != ((gdouble) R)) {
#line 1287 "page-view.c"
					guchar p[3] = {0};
					guchar _tmp51_;
					guchar _tmp52_;
					guchar _tmp53_;
#line 357 "../src/page-view.vala"
					page_view_get_pixel (self, page, R, y, p, (gint) 3);
#line 358 "../src/page-view.vala"
					_tmp51_ = p[0];
#line 358 "../src/page-view.vala"
					red += _tmp51_ * (r - R);
#line 359 "../src/page-view.vala"
					_tmp52_ = p[1];
#line 359 "../src/page-view.vala"
					green += _tmp52_ * (r - R);
#line 360 "../src/page-view.vala"
					_tmp53_ = p[2];
#line 360 "../src/page-view.vala"
					blue += _tmp53_ * (r - R);
#line 1306 "page-view.c"
				}
			}
		}
	}
#line 365 "../src/page-view.vala"
	if (l != ((gdouble) L)) {
#line 365 "../src/page-view.vala"
		_tmp54_ = t != ((gdouble) T);
#line 1315 "page-view.c"
	} else {
#line 365 "../src/page-view.vala"
		_tmp54_ = FALSE;
#line 1319 "page-view.c"
	}
#line 365 "../src/page-view.vala"
	if (_tmp54_) {
#line 1323 "page-view.c"
		guchar p[3] = {0};
		guchar _tmp55_;
		guchar _tmp56_;
		guchar _tmp57_;
#line 368 "../src/page-view.vala"
		page_view_get_pixel (self, page, L - 1, T - 1, p, (gint) 3);
#line 369 "../src/page-view.vala"
		_tmp55_ = p[0];
#line 369 "../src/page-view.vala"
		red += (_tmp55_ * (L - l)) * (T - t);
#line 370 "../src/page-view.vala"
		_tmp56_ = p[1];
#line 370 "../src/page-view.vala"
		green += (_tmp56_ * (L - l)) * (T - t);
#line 371 "../src/page-view.vala"
		_tmp57_ = p[2];
#line 371 "../src/page-view.vala"
		blue += (_tmp57_ * (L - l)) * (T - t);
#line 1342 "page-view.c"
	}
#line 373 "../src/page-view.vala"
	if (r != ((gdouble) R)) {
#line 373 "../src/page-view.vala"
		_tmp58_ = t != ((gdouble) T);
#line 1348 "page-view.c"
	} else {
#line 373 "../src/page-view.vala"
		_tmp58_ = FALSE;
#line 1352 "page-view.c"
	}
#line 373 "../src/page-view.vala"
	if (_tmp58_) {
#line 1356 "page-view.c"
		guchar p[3] = {0};
		guchar _tmp59_;
		guchar _tmp60_;
		guchar _tmp61_;
#line 376 "../src/page-view.vala"
		page_view_get_pixel (self, page, R, T - 1, p, (gint) 3);
#line 377 "../src/page-view.vala"
		_tmp59_ = p[0];
#line 377 "../src/page-view.vala"
		red += (_tmp59_ * (r - R)) * (T - t);
#line 378 "../src/page-view.vala"
		_tmp60_ = p[1];
#line 378 "../src/page-view.vala"
		green += (_tmp60_ * (r - R)) * (T - t);
#line 379 "../src/page-view.vala"
		_tmp61_ = p[2];
#line 379 "../src/page-view.vala"
		blue += (_tmp61_ * (r - R)) * (T - t);
#line 1375 "page-view.c"
	}
#line 381 "../src/page-view.vala"
	if (r != ((gdouble) R)) {
#line 381 "../src/page-view.vala"
		_tmp62_ = b != ((gdouble) B);
#line 1381 "page-view.c"
	} else {
#line 381 "../src/page-view.vala"
		_tmp62_ = FALSE;
#line 1385 "page-view.c"
	}
#line 381 "../src/page-view.vala"
	if (_tmp62_) {
#line 1389 "page-view.c"
		guchar p[3] = {0};
		guchar _tmp63_;
		guchar _tmp64_;
		guchar _tmp65_;
#line 384 "../src/page-view.vala"
		page_view_get_pixel (self, page, R, B, p, (gint) 3);
#line 385 "../src/page-view.vala"
		_tmp63_ = p[0];
#line 385 "../src/page-view.vala"
		red += (_tmp63_ * (r - R)) * (b - B);
#line 386 "../src/page-view.vala"
		_tmp64_ = p[1];
#line 386 "../src/page-view.vala"
		green += (_tmp64_ * (r - R)) * (b - B);
#line 387 "../src/page-view.vala"
		_tmp65_ = p[2];
#line 387 "../src/page-view.vala"
		blue += (_tmp65_ * (r - R)) * (b - B);
#line 1408 "page-view.c"
	}
#line 389 "../src/page-view.vala"
	if (l != ((gdouble) L)) {
#line 389 "../src/page-view.vala"
		_tmp66_ = b != ((gdouble) B);
#line 1414 "page-view.c"
	} else {
#line 389 "../src/page-view.vala"
		_tmp66_ = FALSE;
#line 1418 "page-view.c"
	}
#line 389 "../src/page-view.vala"
	if (_tmp66_) {
#line 1422 "page-view.c"
		guchar p[3] = {0};
		guchar _tmp67_;
		guchar _tmp68_;
		guchar _tmp69_;
#line 392 "../src/page-view.vala"
		page_view_get_pixel (self, page, L - 1, B, p, (gint) 3);
#line 393 "../src/page-view.vala"
		_tmp67_ = p[0];
#line 393 "../src/page-view.vala"
		red += (_tmp67_ * (L - l)) * (b - B);
#line 394 "../src/page-view.vala"
		_tmp68_ = p[1];
#line 394 "../src/page-view.vala"
		green += (_tmp68_ * (L - l)) * (b - B);
#line 395 "../src/page-view.vala"
		_tmp69_ = p[2];
#line 395 "../src/page-view.vala"
		blue += (_tmp69_ * (L - l)) * (b - B);
#line 1441 "page-view.c"
	}
#line 399 "../src/page-view.vala"
	scale = 1.0 / ((r - l) * (b - t));
#line 400 "../src/page-view.vala"
	output[offset] = (guchar) ((red * scale) + 0.5);
#line 401 "../src/page-view.vala"
	output[offset + 1] = (guchar) ((green * scale) + 0.5);
#line 402 "../src/page-view.vala"
	output[offset + 2] = (guchar) ((blue * scale) + 0.5);
#line 1451 "page-view.c"
}

static void
page_view_update_preview (PageView* self,
                          Page* page,
                          GdkPixbuf* * output_image,
                          gint output_width,
                          gint output_height,
                          ScanDirection scan_direction,
                          gint old_scan_line,
                          gint scan_line)
{
	gint input_width = 0;
	gint _tmp0_;
	gint _tmp1_;
	gint input_height = 0;
	gint _tmp2_;
	gint _tmp3_;
	gint L = 0;
	gint R = 0;
	gint T = 0;
	gint B = 0;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	guchar* output = NULL;
	guint8* _tmp11_;
	gint output_length1;
	gint _output_size_;
	gint output_rowstride = 0;
	gint _tmp12_;
	gint _tmp13_;
	gint output_n_channels = 0;
	gint _tmp14_;
	gint _tmp15_;
	gboolean _tmp16_;
	gboolean _tmp17_;
#line 405 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 405 "../src/page-view.vala"
	g_return_if_fail (page != NULL);
#line 408 "../src/page-view.vala"
	_tmp0_ = page_get_width (page);
#line 408 "../src/page-view.vala"
	_tmp1_ = _tmp0_;
#line 408 "../src/page-view.vala"
	input_width = _tmp1_;
#line 409 "../src/page-view.vala"
	_tmp2_ = page_get_height (page);
#line 409 "../src/page-view.vala"
	_tmp3_ = _tmp2_;
#line 409 "../src/page-view.vala"
	input_height = _tmp3_;
#line 413 "../src/page-view.vala"
	if ((*output_image) == NULL) {
#line 413 "../src/page-view.vala"
		_tmp5_ = TRUE;
#line 1508 "page-view.c"
	} else {
		gint _tmp6_;
		gint _tmp7_;
#line 414 "../src/page-view.vala"
		_tmp6_ = gdk_pixbuf_get_width (*output_image);
#line 414 "../src/page-view.vala"
		_tmp7_ = _tmp6_;
#line 414 "../src/page-view.vala"
		_tmp5_ = _tmp7_ != output_width;
#line 1518 "page-view.c"
	}
#line 413 "../src/page-view.vala"
	if (_tmp5_) {
#line 413 "../src/page-view.vala"
		_tmp4_ = TRUE;
#line 1524 "page-view.c"
	} else {
		gint _tmp8_;
		gint _tmp9_;
#line 415 "../src/page-view.vala"
		_tmp8_ = gdk_pixbuf_get_height (*output_image);
#line 415 "../src/page-view.vala"
		_tmp9_ = _tmp8_;
#line 415 "../src/page-view.vala"
		_tmp4_ = _tmp9_ != output_height;
#line 1534 "page-view.c"
	}
#line 413 "../src/page-view.vala"
	if (_tmp4_) {
#line 1538 "page-view.c"
		GdkPixbuf* _tmp10_;
#line 417 "../src/page-view.vala"
		_tmp10_ = gdk_pixbuf_new (GDK_COLORSPACE_RGB, FALSE, 8, output_width, output_height);
#line 417 "../src/page-view.vala"
		_g_object_unref0 (*output_image);
#line 417 "../src/page-view.vala"
		*output_image = _tmp10_;
#line 424 "../src/page-view.vala"
		L = 0;
#line 425 "../src/page-view.vala"
		R = output_width - 1;
#line 426 "../src/page-view.vala"
		T = 0;
#line 427 "../src/page-view.vala"
		B = output_height - 1;
#line 1554 "page-view.c"
	} else {
#line 432 "../src/page-view.vala"
		switch (scan_direction) {
#line 432 "../src/page-view.vala"
			case SCAN_DIRECTION_TOP_TO_BOTTOM:
#line 1560 "page-view.c"
			{
#line 435 "../src/page-view.vala"
				L = 0;
#line 436 "../src/page-view.vala"
				R = output_width - 1;
#line 437 "../src/page-view.vala"
				T = (gint) ((((gdouble) old_scan_line) * output_height) / input_height);
#line 438 "../src/page-view.vala"
				B = (gint) (((((gdouble) scan_line) * output_height) / input_height) + 0.5);
#line 439 "../src/page-view.vala"
				break;
#line 1572 "page-view.c"
			}
#line 432 "../src/page-view.vala"
			case SCAN_DIRECTION_LEFT_TO_RIGHT:
#line 1576 "page-view.c"
			{
#line 441 "../src/page-view.vala"
				L = (gint) ((((gdouble) old_scan_line) * output_width) / input_width);
#line 442 "../src/page-view.vala"
				R = (gint) (((((gdouble) scan_line) * output_width) / input_width) + 0.5);
#line 443 "../src/page-view.vala"
				T = 0;
#line 444 "../src/page-view.vala"
				B = output_height - 1;
#line 445 "../src/page-view.vala"
				break;
#line 1588 "page-view.c"
			}
#line 432 "../src/page-view.vala"
			case SCAN_DIRECTION_BOTTOM_TO_TOP:
#line 1592 "page-view.c"
			{
#line 447 "../src/page-view.vala"
				L = 0;
#line 448 "../src/page-view.vala"
				R = output_width - 1;
#line 449 "../src/page-view.vala"
				T = (gint) ((((gdouble) (input_height - scan_line)) * output_height) / input_height);
#line 450 "../src/page-view.vala"
				B = (gint) (((((gdouble) (input_height - old_scan_line)) * output_height) / input_height) + 0.5);
#line 451 "../src/page-view.vala"
				break;
#line 1604 "page-view.c"
			}
#line 432 "../src/page-view.vala"
			case SCAN_DIRECTION_RIGHT_TO_LEFT:
#line 1608 "page-view.c"
			{
#line 453 "../src/page-view.vala"
				L = (gint) ((((gdouble) (input_width - scan_line)) * output_width) / input_width);
#line 454 "../src/page-view.vala"
				R = (gint) (((((gdouble) (input_width - old_scan_line)) * output_width) / input_width) + 0.5);
#line 455 "../src/page-view.vala"
				T = 0;
#line 456 "../src/page-view.vala"
				B = output_height - 1;
#line 457 "../src/page-view.vala"
				break;
#line 1620 "page-view.c"
			}
			default:
			{
#line 459 "../src/page-view.vala"
				T = 0;
#line 459 "../src/page-view.vala"
				B = T;
#line 459 "../src/page-view.vala"
				R = B;
#line 459 "../src/page-view.vala"
				L = R;
#line 460 "../src/page-view.vala"
				break;
#line 1634 "page-view.c"
			}
		}
	}
#line 465 "../src/page-view.vala"
	if (R >= output_width) {
#line 466 "../src/page-view.vala"
		R = output_width - 1;
#line 1642 "page-view.c"
	}
#line 467 "../src/page-view.vala"
	if (B >= output_height) {
#line 468 "../src/page-view.vala"
		B = output_height - 1;
#line 1648 "page-view.c"
	}
#line 470 "../src/page-view.vala"
	g_return_if_fail (L >= 0);
#line 471 "../src/page-view.vala"
	g_return_if_fail (R < output_width);
#line 472 "../src/page-view.vala"
	g_return_if_fail (T >= 0);
#line 473 "../src/page-view.vala"
	g_return_if_fail (B < output_height);
#line 474 "../src/page-view.vala"
	g_return_if_fail ((*output_image) != NULL);
#line 476 "../src/page-view.vala"
	_tmp11_ = gdk_pixbuf_get_pixels (*output_image);
#line 476 "../src/page-view.vala"
	output = _tmp11_;
#line 476 "../src/page-view.vala"
	output_length1 = -1;
#line 476 "../src/page-view.vala"
	_output_size_ = output_length1;
#line 477 "../src/page-view.vala"
	_tmp12_ = gdk_pixbuf_get_rowstride (*output_image);
#line 477 "../src/page-view.vala"
	_tmp13_ = _tmp12_;
#line 477 "../src/page-view.vala"
	output_rowstride = _tmp13_;
#line 478 "../src/page-view.vala"
	_tmp14_ = gdk_pixbuf_get_n_channels (*output_image);
#line 478 "../src/page-view.vala"
	_tmp15_ = _tmp14_;
#line 478 "../src/page-view.vala"
	output_n_channels = _tmp15_;
#line 480 "../src/page-view.vala"
	_tmp16_ = page_get_has_data (page);
#line 480 "../src/page-view.vala"
	_tmp17_ = _tmp16_;
#line 480 "../src/page-view.vala"
	if (!_tmp17_) {
#line 1686 "page-view.c"
		{
			gint x = 0;
#line 482 "../src/page-view.vala"
			x = L;
#line 1691 "page-view.c"
			{
				gboolean _tmp18_ = FALSE;
#line 482 "../src/page-view.vala"
				_tmp18_ = TRUE;
#line 482 "../src/page-view.vala"
				while (TRUE) {
#line 482 "../src/page-view.vala"
					if (!_tmp18_) {
#line 1700 "page-view.c"
						gint _tmp19_;
#line 482 "../src/page-view.vala"
						_tmp19_ = x;
#line 482 "../src/page-view.vala"
						x = _tmp19_ + 1;
#line 1706 "page-view.c"
					}
#line 482 "../src/page-view.vala"
					_tmp18_ = FALSE;
#line 482 "../src/page-view.vala"
					if (!(x <= R)) {
#line 482 "../src/page-view.vala"
						break;
#line 1714 "page-view.c"
					}
					{
						gint y = 0;
#line 483 "../src/page-view.vala"
						y = T;
#line 1720 "page-view.c"
						{
							gboolean _tmp20_ = FALSE;
#line 483 "../src/page-view.vala"
							_tmp20_ = TRUE;
#line 483 "../src/page-view.vala"
							while (TRUE) {
#line 1727 "page-view.c"
								gint o = 0;
								guchar* _tmp22_;
								gint _tmp22__length1;
								guchar* _tmp23_;
								gint _tmp23__length1;
								guchar* _tmp24_;
								gint _tmp24__length1;
#line 483 "../src/page-view.vala"
								if (!_tmp20_) {
#line 1737 "page-view.c"
									gint _tmp21_;
#line 483 "../src/page-view.vala"
									_tmp21_ = y;
#line 483 "../src/page-view.vala"
									y = _tmp21_ + 1;
#line 1743 "page-view.c"
								}
#line 483 "../src/page-view.vala"
								_tmp20_ = FALSE;
#line 483 "../src/page-view.vala"
								if (!(y <= B)) {
#line 483 "../src/page-view.vala"
									break;
#line 1751 "page-view.c"
								}
#line 485 "../src/page-view.vala"
								o = (output_rowstride * y) + (x * output_n_channels);
#line 486 "../src/page-view.vala"
								_tmp22_ = output;
#line 486 "../src/page-view.vala"
								_tmp22__length1 = output_length1;
#line 486 "../src/page-view.vala"
								_tmp23_ = output;
#line 486 "../src/page-view.vala"
								_tmp23__length1 = output_length1;
#line 486 "../src/page-view.vala"
								_tmp24_ = output;
#line 486 "../src/page-view.vala"
								_tmp24__length1 = output_length1;
#line 486 "../src/page-view.vala"
								_tmp24_[o + 2] = (guchar) 0xFF;
#line 486 "../src/page-view.vala"
								_tmp23_[o + 1] = (guchar) 0xFF;
#line 486 "../src/page-view.vala"
								_tmp22_[o] = (guchar) 0xFF;
#line 1773 "page-view.c"
							}
						}
					}
				}
			}
		}
#line 488 "../src/page-view.vala"
		return;
#line 1782 "page-view.c"
	}
	{
		gint x = 0;
#line 492 "../src/page-view.vala"
		x = L;
#line 1788 "page-view.c"
		{
			gboolean _tmp25_ = FALSE;
#line 492 "../src/page-view.vala"
			_tmp25_ = TRUE;
#line 492 "../src/page-view.vala"
			while (TRUE) {
#line 1795 "page-view.c"
				gdouble l = 0.0;
				gdouble r = 0.0;
#line 492 "../src/page-view.vala"
				if (!_tmp25_) {
#line 1800 "page-view.c"
					gint _tmp26_;
#line 492 "../src/page-view.vala"
					_tmp26_ = x;
#line 492 "../src/page-view.vala"
					x = _tmp26_ + 1;
#line 1806 "page-view.c"
				}
#line 492 "../src/page-view.vala"
				_tmp25_ = FALSE;
#line 492 "../src/page-view.vala"
				if (!(x <= R)) {
#line 492 "../src/page-view.vala"
					break;
#line 1814 "page-view.c"
				}
#line 494 "../src/page-view.vala"
				l = (((gdouble) x) * input_width) / output_width;
#line 495 "../src/page-view.vala"
				r = (((gdouble) (x + 1)) * input_width) / output_width;
#line 1820 "page-view.c"
				{
					gint y = 0;
#line 497 "../src/page-view.vala"
					y = T;
#line 1825 "page-view.c"
					{
						gboolean _tmp27_ = FALSE;
#line 497 "../src/page-view.vala"
						_tmp27_ = TRUE;
#line 497 "../src/page-view.vala"
						while (TRUE) {
#line 1832 "page-view.c"
							gdouble t = 0.0;
							gdouble b = 0.0;
							guchar* _tmp29_;
							gint _tmp29__length1;
#line 497 "../src/page-view.vala"
							if (!_tmp27_) {
#line 1839 "page-view.c"
								gint _tmp28_;
#line 497 "../src/page-view.vala"
								_tmp28_ = y;
#line 497 "../src/page-view.vala"
								y = _tmp28_ + 1;
#line 1845 "page-view.c"
							}
#line 497 "../src/page-view.vala"
							_tmp27_ = FALSE;
#line 497 "../src/page-view.vala"
							if (!(y <= B)) {
#line 497 "../src/page-view.vala"
								break;
#line 1853 "page-view.c"
							}
#line 499 "../src/page-view.vala"
							t = (((gdouble) y) * input_height) / output_height;
#line 500 "../src/page-view.vala"
							b = (((gdouble) (y + 1)) * input_height) / output_height;
#line 502 "../src/page-view.vala"
							_tmp29_ = output;
#line 502 "../src/page-view.vala"
							_tmp29__length1 = output_length1;
#line 502 "../src/page-view.vala"
							page_view_set_pixel (self, page, l, r, t, b, _tmp29_, (gint) _tmp29__length1, (output_rowstride * y) + (x * output_n_channels));
#line 1865 "page-view.c"
						}
					}
				}
			}
		}
	}
}

static gint
page_view_get_preview_width (PageView* self)
{
	gint result = 0;
#line 509 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 511 "../src/page-view.vala"
	result = self->priv->width_ - (self->priv->border_width * 2);
#line 511 "../src/page-view.vala"
	return result;
#line 1884 "page-view.c"
}

static gint
page_view_get_preview_height (PageView* self)
{
	gint result = 0;
#line 514 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 516 "../src/page-view.vala"
	result = self->priv->height_ - (self->priv->border_width * 2);
#line 516 "../src/page-view.vala"
	return result;
#line 1897 "page-view.c"
}

static void
page_view_update_page_view (PageView* self)
{
	gint old_scan_line = 0;
	gint scan_line = 0;
	Page* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	ScanDirection left_steps = 0;
	ScanDirection _tmp3_;
	Page* _tmp4_;
	ScanDirection _tmp5_;
	ScanDirection _tmp6_;
	gboolean _tmp7_ = FALSE;
	ScanDirection _tmp8_;
	Page* _tmp10_;
	ScanDirection _tmp11_;
	ScanDirection _tmp12_;
	Page* _tmp13_;
	Page* _tmp14_;
	ScanDirection _tmp15_;
	ScanDirection _tmp16_;
#line 519 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 521 "../src/page-view.vala"
	if (!self->priv->update_image) {
#line 522 "../src/page-view.vala"
		return;
#line 1928 "page-view.c"
	}
#line 524 "../src/page-view.vala"
	old_scan_line = self->priv->scan_line;
#line 525 "../src/page-view.vala"
	_tmp0_ = self->priv->_page;
#line 525 "../src/page-view.vala"
	_tmp1_ = page_get_scan_line (_tmp0_);
#line 525 "../src/page-view.vala"
	_tmp2_ = _tmp1_;
#line 525 "../src/page-view.vala"
	scan_line = _tmp2_;
#line 528 "../src/page-view.vala"
	_tmp3_ = self->priv->scan_direction;
#line 528 "../src/page-view.vala"
	_tmp4_ = self->priv->_page;
#line 528 "../src/page-view.vala"
	_tmp5_ = page_get_scan_direction (_tmp4_);
#line 528 "../src/page-view.vala"
	_tmp6_ = _tmp5_;
#line 528 "../src/page-view.vala"
	left_steps = _tmp3_ - _tmp6_;
#line 529 "../src/page-view.vala"
	_tmp8_ = left_steps;
#line 529 "../src/page-view.vala"
	if (_tmp8_ != 0) {
#line 1954 "page-view.c"
		GdkPixbuf* _tmp9_;
#line 529 "../src/page-view.vala"
		_tmp9_ = self->priv->image;
#line 529 "../src/page-view.vala"
		_tmp7_ = _tmp9_ != NULL;
#line 1960 "page-view.c"
	} else {
#line 529 "../src/page-view.vala"
		_tmp7_ = FALSE;
#line 1964 "page-view.c"
	}
#line 529 "../src/page-view.vala"
	if (_tmp7_) {
#line 530 "../src/page-view.vala"
		_g_object_unref0 (self->priv->image);
#line 530 "../src/page-view.vala"
		self->priv->image = NULL;
#line 1972 "page-view.c"
	}
#line 531 "../src/page-view.vala"
	_tmp10_ = self->priv->_page;
#line 531 "../src/page-view.vala"
	_tmp11_ = page_get_scan_direction (_tmp10_);
#line 531 "../src/page-view.vala"
	_tmp12_ = _tmp11_;
#line 531 "../src/page-view.vala"
	self->priv->scan_direction = _tmp12_;
#line 533 "../src/page-view.vala"
	_tmp13_ = self->priv->_page;
#line 533 "../src/page-view.vala"
	_tmp14_ = self->priv->_page;
#line 533 "../src/page-view.vala"
	_tmp15_ = page_get_scan_direction (_tmp14_);
#line 533 "../src/page-view.vala"
	_tmp16_ = _tmp15_;
#line 533 "../src/page-view.vala"
	page_view_update_preview (self, _tmp13_, &self->priv->image, page_view_get_preview_width (self), page_view_get_preview_height (self), _tmp16_, old_scan_line, scan_line);
#line 539 "../src/page-view.vala"
	self->priv->update_image = FALSE;
#line 540 "../src/page-view.vala"
	self->priv->scan_line = scan_line;
#line 1996 "page-view.c"
}

static gint
page_view_page_to_screen_x (PageView* self,
                            gint x)
{
	Page* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint result = 0;
#line 543 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 545 "../src/page-view.vala"
	_tmp0_ = self->priv->_page;
#line 545 "../src/page-view.vala"
	_tmp1_ = page_get_width (_tmp0_);
#line 545 "../src/page-view.vala"
	_tmp2_ = _tmp1_;
#line 545 "../src/page-view.vala"
	result = (gint) (((((gdouble) x) * page_view_get_preview_width (self)) / _tmp2_) + 0.5);
#line 545 "../src/page-view.vala"
	return result;
#line 2019 "page-view.c"
}

static gint
page_view_page_to_screen_y (PageView* self,
                            gint y)
{
	Page* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint result = 0;
#line 548 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 550 "../src/page-view.vala"
	_tmp0_ = self->priv->_page;
#line 550 "../src/page-view.vala"
	_tmp1_ = page_get_height (_tmp0_);
#line 550 "../src/page-view.vala"
	_tmp2_ = _tmp1_;
#line 550 "../src/page-view.vala"
	result = (gint) (((((gdouble) y) * page_view_get_preview_height (self)) / _tmp2_) + 0.5);
#line 550 "../src/page-view.vala"
	return result;
#line 2042 "page-view.c"
}

static gint
page_view_screen_to_page_x (PageView* self,
                            gint x)
{
	Page* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint result = 0;
#line 553 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 555 "../src/page-view.vala"
	_tmp0_ = self->priv->_page;
#line 555 "../src/page-view.vala"
	_tmp1_ = page_get_width (_tmp0_);
#line 555 "../src/page-view.vala"
	_tmp2_ = _tmp1_;
#line 555 "../src/page-view.vala"
	result = (gint) (((((gdouble) x) * _tmp2_) / page_view_get_preview_width (self)) + 0.5);
#line 555 "../src/page-view.vala"
	return result;
#line 2065 "page-view.c"
}

static gint
page_view_screen_to_page_y (PageView* self,
                            gint y)
{
	Page* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint result = 0;
#line 558 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 560 "../src/page-view.vala"
	_tmp0_ = self->priv->_page;
#line 560 "../src/page-view.vala"
	_tmp1_ = page_get_height (_tmp0_);
#line 560 "../src/page-view.vala"
	_tmp2_ = _tmp1_;
#line 560 "../src/page-view.vala"
	result = (gint) (((((gdouble) y) * _tmp2_) / page_view_get_preview_height (self)) + 0.5);
#line 560 "../src/page-view.vala"
	return result;
#line 2088 "page-view.c"
}

static CropLocation
page_view_get_crop_location (PageView* self,
                             gint x,
                             gint y)
{
	Page* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gint cx = 0;
	Page* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint cy = 0;
	Page* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint cw = 0;
	Page* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gint ch = 0;
	Page* _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	gint dx = 0;
	gint dy = 0;
	gint dw = 0;
	gint dh = 0;
	gint ix = 0;
	gint iy = 0;
	gboolean _tmp15_ = FALSE;
	gboolean _tmp16_ = FALSE;
	gboolean _tmp17_ = FALSE;
	gchar* name = NULL;
	Page* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	gchar* _tmp21_;
	const gchar* _tmp22_;
	gint crop_border = 0;
	gboolean _tmp23_ = FALSE;
	gboolean _tmp24_ = FALSE;
	gboolean _tmp25_ = FALSE;
	gboolean _tmp26_ = FALSE;
	CropLocation result = 0;
#line 563 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 565 "../src/page-view.vala"
	_tmp0_ = self->priv->_page;
#line 565 "../src/page-view.vala"
	_tmp1_ = page_get_has_crop (_tmp0_);
#line 565 "../src/page-view.vala"
	_tmp2_ = _tmp1_;
#line 565 "../src/page-view.vala"
	if (!_tmp2_) {
#line 566 "../src/page-view.vala"
		result = CROP_LOCATION_NONE;
#line 566 "../src/page-view.vala"
		return result;
#line 2150 "page-view.c"
	}
#line 568 "../src/page-view.vala"
	_tmp3_ = self->priv->_page;
#line 568 "../src/page-view.vala"
	_tmp4_ = page_get_crop_x (_tmp3_);
#line 568 "../src/page-view.vala"
	_tmp5_ = _tmp4_;
#line 568 "../src/page-view.vala"
	cx = _tmp5_;
#line 569 "../src/page-view.vala"
	_tmp6_ = self->priv->_page;
#line 569 "../src/page-view.vala"
	_tmp7_ = page_get_crop_y (_tmp6_);
#line 569 "../src/page-view.vala"
	_tmp8_ = _tmp7_;
#line 569 "../src/page-view.vala"
	cy = _tmp8_;
#line 570 "../src/page-view.vala"
	_tmp9_ = self->priv->_page;
#line 570 "../src/page-view.vala"
	_tmp10_ = page_get_crop_width (_tmp9_);
#line 570 "../src/page-view.vala"
	_tmp11_ = _tmp10_;
#line 570 "../src/page-view.vala"
	cw = _tmp11_;
#line 571 "../src/page-view.vala"
	_tmp12_ = self->priv->_page;
#line 571 "../src/page-view.vala"
	_tmp13_ = page_get_crop_height (_tmp12_);
#line 571 "../src/page-view.vala"
	_tmp14_ = _tmp13_;
#line 571 "../src/page-view.vala"
	ch = _tmp14_;
#line 572 "../src/page-view.vala"
	dx = page_view_page_to_screen_x (self, cx);
#line 573 "../src/page-view.vala"
	dy = page_view_page_to_screen_y (self, cy);
#line 574 "../src/page-view.vala"
	dw = page_view_page_to_screen_x (self, cw);
#line 575 "../src/page-view.vala"
	dh = page_view_page_to_screen_y (self, ch);
#line 576 "../src/page-view.vala"
	ix = x - dx;
#line 577 "../src/page-view.vala"
	iy = y - dy;
#line 579 "../src/page-view.vala"
	if (ix < 0) {
#line 579 "../src/page-view.vala"
		_tmp17_ = TRUE;
#line 2200 "page-view.c"
	} else {
#line 579 "../src/page-view.vala"
		_tmp17_ = ix > dw;
#line 2204 "page-view.c"
	}
#line 579 "../src/page-view.vala"
	if (_tmp17_) {
#line 579 "../src/page-view.vala"
		_tmp16_ = TRUE;
#line 2210 "page-view.c"
	} else {
#line 579 "../src/page-view.vala"
		_tmp16_ = iy < 0;
#line 2214 "page-view.c"
	}
#line 579 "../src/page-view.vala"
	if (_tmp16_) {
#line 579 "../src/page-view.vala"
		_tmp15_ = TRUE;
#line 2220 "page-view.c"
	} else {
#line 579 "../src/page-view.vala"
		_tmp15_ = iy > dh;
#line 2224 "page-view.c"
	}
#line 579 "../src/page-view.vala"
	if (_tmp15_) {
#line 580 "../src/page-view.vala"
		result = CROP_LOCATION_NONE;
#line 580 "../src/page-view.vala"
		return result;
#line 2232 "page-view.c"
	}
#line 583 "../src/page-view.vala"
	_tmp18_ = self->priv->_page;
#line 583 "../src/page-view.vala"
	_tmp19_ = page_get_crop_name (_tmp18_);
#line 583 "../src/page-view.vala"
	_tmp20_ = _tmp19_;
#line 583 "../src/page-view.vala"
	_tmp21_ = g_strdup (_tmp20_);
#line 583 "../src/page-view.vala"
	name = _tmp21_;
#line 584 "../src/page-view.vala"
	_tmp22_ = name;
#line 584 "../src/page-view.vala"
	if (_tmp22_ != NULL) {
#line 585 "../src/page-view.vala"
		result = CROP_LOCATION_MIDDLE;
#line 585 "../src/page-view.vala"
		_g_free0 (name);
#line 585 "../src/page-view.vala"
		return result;
#line 2254 "page-view.c"
	}
#line 588 "../src/page-view.vala"
	crop_border = 20;
#line 589 "../src/page-view.vala"
	if (dw < (crop_border * 3)) {
#line 590 "../src/page-view.vala"
		crop_border = dw / 3;
#line 2262 "page-view.c"
	}
#line 591 "../src/page-view.vala"
	if (dh < (crop_border * 3)) {
#line 592 "../src/page-view.vala"
		crop_border = dh / 3;
#line 2268 "page-view.c"
	}
#line 595 "../src/page-view.vala"
	if (ix < crop_border) {
#line 595 "../src/page-view.vala"
		_tmp23_ = iy < crop_border;
#line 2274 "page-view.c"
	} else {
#line 595 "../src/page-view.vala"
		_tmp23_ = FALSE;
#line 2278 "page-view.c"
	}
#line 595 "../src/page-view.vala"
	if (_tmp23_) {
#line 596 "../src/page-view.vala"
		result = CROP_LOCATION_TOP_LEFT;
#line 596 "../src/page-view.vala"
		_g_free0 (name);
#line 596 "../src/page-view.vala"
		return result;
#line 2288 "page-view.c"
	}
#line 598 "../src/page-view.vala"
	if (ix > (dw - crop_border)) {
#line 598 "../src/page-view.vala"
		_tmp24_ = iy < crop_border;
#line 2294 "page-view.c"
	} else {
#line 598 "../src/page-view.vala"
		_tmp24_ = FALSE;
#line 2298 "page-view.c"
	}
#line 598 "../src/page-view.vala"
	if (_tmp24_) {
#line 599 "../src/page-view.vala"
		result = CROP_LOCATION_TOP_RIGHT;
#line 599 "../src/page-view.vala"
		_g_free0 (name);
#line 599 "../src/page-view.vala"
		return result;
#line 2308 "page-view.c"
	}
#line 601 "../src/page-view.vala"
	if (ix < crop_border) {
#line 601 "../src/page-view.vala"
		_tmp25_ = iy > (dh - crop_border);
#line 2314 "page-view.c"
	} else {
#line 601 "../src/page-view.vala"
		_tmp25_ = FALSE;
#line 2318 "page-view.c"
	}
#line 601 "../src/page-view.vala"
	if (_tmp25_) {
#line 602 "../src/page-view.vala"
		result = CROP_LOCATION_BOTTOM_LEFT;
#line 602 "../src/page-view.vala"
		_g_free0 (name);
#line 602 "../src/page-view.vala"
		return result;
#line 2328 "page-view.c"
	}
#line 604 "../src/page-view.vala"
	if (ix > (dw - crop_border)) {
#line 604 "../src/page-view.vala"
		_tmp26_ = iy > (dh - crop_border);
#line 2334 "page-view.c"
	} else {
#line 604 "../src/page-view.vala"
		_tmp26_ = FALSE;
#line 2338 "page-view.c"
	}
#line 604 "../src/page-view.vala"
	if (_tmp26_) {
#line 605 "../src/page-view.vala"
		result = CROP_LOCATION_BOTTOM_RIGHT;
#line 605 "../src/page-view.vala"
		_g_free0 (name);
#line 605 "../src/page-view.vala"
		return result;
#line 2348 "page-view.c"
	}
#line 608 "../src/page-view.vala"
	if (ix < crop_border) {
#line 609 "../src/page-view.vala"
		result = CROP_LOCATION_LEFT;
#line 609 "../src/page-view.vala"
		_g_free0 (name);
#line 609 "../src/page-view.vala"
		return result;
#line 2358 "page-view.c"
	}
#line 611 "../src/page-view.vala"
	if (ix > (dw - crop_border)) {
#line 612 "../src/page-view.vala"
		result = CROP_LOCATION_RIGHT;
#line 612 "../src/page-view.vala"
		_g_free0 (name);
#line 612 "../src/page-view.vala"
		return result;
#line 2368 "page-view.c"
	}
#line 614 "../src/page-view.vala"
	if (iy < crop_border) {
#line 615 "../src/page-view.vala"
		result = CROP_LOCATION_TOP;
#line 615 "../src/page-view.vala"
		_g_free0 (name);
#line 615 "../src/page-view.vala"
		return result;
#line 2378 "page-view.c"
	}
#line 617 "../src/page-view.vala"
	if (iy > (dh - crop_border)) {
#line 618 "../src/page-view.vala"
		result = CROP_LOCATION_BOTTOM;
#line 618 "../src/page-view.vala"
		_g_free0 (name);
#line 618 "../src/page-view.vala"
		return result;
#line 2388 "page-view.c"
	}
#line 621 "../src/page-view.vala"
	result = CROP_LOCATION_MIDDLE;
#line 621 "../src/page-view.vala"
	_g_free0 (name);
#line 621 "../src/page-view.vala"
	return result;
#line 2396 "page-view.c"
}

void
page_view_button_press (PageView* self,
                        gint x,
                        gint y)
{
	CropLocation location = 0;
	CropLocation _tmp0_;
#line 624 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 627 "../src/page-view.vala"
	location = page_view_get_crop_location (self, x, y);
#line 628 "../src/page-view.vala"
	_tmp0_ = location;
#line 628 "../src/page-view.vala"
	if (_tmp0_ != CROP_LOCATION_NONE) {
#line 2414 "page-view.c"
		CropLocation _tmp1_;
		Page* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		Page* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		Page* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		Page* _tmp11_;
		gint _tmp12_;
		gint _tmp13_;
#line 630 "../src/page-view.vala"
		_tmp1_ = location;
#line 630 "../src/page-view.vala"
		self->priv->crop_location = _tmp1_;
#line 631 "../src/page-view.vala"
		self->priv->selected_crop_px = (gdouble) x;
#line 632 "../src/page-view.vala"
		self->priv->selected_crop_py = (gdouble) y;
#line 633 "../src/page-view.vala"
		_tmp2_ = self->priv->_page;
#line 633 "../src/page-view.vala"
		_tmp3_ = page_get_crop_x (_tmp2_);
#line 633 "../src/page-view.vala"
		_tmp4_ = _tmp3_;
#line 633 "../src/page-view.vala"
		self->priv->selected_crop_x = _tmp4_;
#line 634 "../src/page-view.vala"
		_tmp5_ = self->priv->_page;
#line 634 "../src/page-view.vala"
		_tmp6_ = page_get_crop_y (_tmp5_);
#line 634 "../src/page-view.vala"
		_tmp7_ = _tmp6_;
#line 634 "../src/page-view.vala"
		self->priv->selected_crop_y = _tmp7_;
#line 635 "../src/page-view.vala"
		_tmp8_ = self->priv->_page;
#line 635 "../src/page-view.vala"
		_tmp9_ = page_get_crop_width (_tmp8_);
#line 635 "../src/page-view.vala"
		_tmp10_ = _tmp9_;
#line 635 "../src/page-view.vala"
		self->priv->selected_crop_w = _tmp10_;
#line 636 "../src/page-view.vala"
		_tmp11_ = self->priv->_page;
#line 636 "../src/page-view.vala"
		_tmp12_ = page_get_crop_height (_tmp11_);
#line 636 "../src/page-view.vala"
		_tmp13_ = _tmp12_;
#line 636 "../src/page-view.vala"
		self->priv->selected_crop_h = _tmp13_;
#line 2468 "page-view.c"
	}
}

void
page_view_motion (PageView* self,
                  gint x,
                  gint y)
{
	CropLocation location = 0;
	GdkCursorType cursor = 0;
	CropLocation _tmp0_;
	CropLocation _tmp1_;
	gint pw = 0;
	Page* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint ph = 0;
	Page* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint cw = 0;
	Page* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gint ch = 0;
	Page* _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	gint dx = 0;
	gint dy = 0;
	gint new_x = 0;
	gint new_y = 0;
	gint new_w = 0;
	gint new_h = 0;
	gint min_size = 0;
	gboolean _tmp15_ = FALSE;
	gboolean _tmp16_ = FALSE;
	CropLocation _tmp17_;
	gboolean _tmp20_ = FALSE;
	gboolean _tmp21_ = FALSE;
	CropLocation _tmp22_;
	gboolean _tmp25_ = FALSE;
	gboolean _tmp26_ = FALSE;
	CropLocation _tmp27_;
	gboolean _tmp30_ = FALSE;
	gboolean _tmp31_ = FALSE;
	CropLocation _tmp32_;
	CropLocation _tmp35_;
	CropLocation _tmp36_;
	gboolean _tmp37_ = FALSE;
	gboolean _tmp38_ = FALSE;
	CropLocation _tmp39_;
	gboolean _tmp42_ = FALSE;
	gboolean _tmp43_ = FALSE;
	CropLocation _tmp44_;
	gboolean _tmp47_ = FALSE;
	gboolean _tmp48_ = FALSE;
	CropLocation _tmp49_;
	gboolean _tmp52_ = FALSE;
	gboolean _tmp53_ = FALSE;
	CropLocation _tmp54_;
	Page* _tmp57_;
	gboolean _tmp58_ = FALSE;
#line 640 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 642 "../src/page-view.vala"
	location = page_view_get_crop_location (self, x, y);
#line 644 "../src/page-view.vala"
	_tmp0_ = location;
#line 644 "../src/page-view.vala"
	switch (_tmp0_) {
#line 644 "../src/page-view.vala"
		case CROP_LOCATION_MIDDLE:
#line 2542 "page-view.c"
		{
#line 647 "../src/page-view.vala"
			cursor = GDK_HAND1;
#line 648 "../src/page-view.vala"
			break;
#line 2548 "page-view.c"
		}
#line 644 "../src/page-view.vala"
		case CROP_LOCATION_TOP:
#line 2552 "page-view.c"
		{
#line 650 "../src/page-view.vala"
			cursor = GDK_TOP_SIDE;
#line 651 "../src/page-view.vala"
			break;
#line 2558 "page-view.c"
		}
#line 644 "../src/page-view.vala"
		case CROP_LOCATION_BOTTOM:
#line 2562 "page-view.c"
		{
#line 653 "../src/page-view.vala"
			cursor = GDK_BOTTOM_SIDE;
#line 654 "../src/page-view.vala"
			break;
#line 2568 "page-view.c"
		}
#line 644 "../src/page-view.vala"
		case CROP_LOCATION_LEFT:
#line 2572 "page-view.c"
		{
#line 656 "../src/page-view.vala"
			cursor = GDK_LEFT_SIDE;
#line 657 "../src/page-view.vala"
			break;
#line 2578 "page-view.c"
		}
#line 644 "../src/page-view.vala"
		case CROP_LOCATION_RIGHT:
#line 2582 "page-view.c"
		{
#line 659 "../src/page-view.vala"
			cursor = GDK_RIGHT_SIDE;
#line 660 "../src/page-view.vala"
			break;
#line 2588 "page-view.c"
		}
#line 644 "../src/page-view.vala"
		case CROP_LOCATION_TOP_LEFT:
#line 2592 "page-view.c"
		{
#line 662 "../src/page-view.vala"
			cursor = GDK_TOP_LEFT_CORNER;
#line 663 "../src/page-view.vala"
			break;
#line 2598 "page-view.c"
		}
#line 644 "../src/page-view.vala"
		case CROP_LOCATION_TOP_RIGHT:
#line 2602 "page-view.c"
		{
#line 665 "../src/page-view.vala"
			cursor = GDK_TOP_RIGHT_CORNER;
#line 666 "../src/page-view.vala"
			break;
#line 2608 "page-view.c"
		}
#line 644 "../src/page-view.vala"
		case CROP_LOCATION_BOTTOM_LEFT:
#line 2612 "page-view.c"
		{
#line 668 "../src/page-view.vala"
			cursor = GDK_BOTTOM_LEFT_CORNER;
#line 669 "../src/page-view.vala"
			break;
#line 2618 "page-view.c"
		}
#line 644 "../src/page-view.vala"
		case CROP_LOCATION_BOTTOM_RIGHT:
#line 2622 "page-view.c"
		{
#line 671 "../src/page-view.vala"
			cursor = GDK_BOTTOM_RIGHT_CORNER;
#line 672 "../src/page-view.vala"
			break;
#line 2628 "page-view.c"
		}
		default:
		{
#line 674 "../src/page-view.vala"
			cursor = GDK_ARROW;
#line 675 "../src/page-view.vala"
			break;
#line 2636 "page-view.c"
		}
	}
#line 678 "../src/page-view.vala"
	_tmp1_ = self->priv->crop_location;
#line 678 "../src/page-view.vala"
	if (_tmp1_ == CROP_LOCATION_NONE) {
#line 2643 "page-view.c"
		GdkCursorType _tmp2_;
#line 680 "../src/page-view.vala"
		_tmp2_ = cursor;
#line 680 "../src/page-view.vala"
		page_view_set_cursor (self, _tmp2_);
#line 681 "../src/page-view.vala"
		return;
#line 2651 "page-view.c"
	}
#line 685 "../src/page-view.vala"
	_tmp3_ = self->priv->_page;
#line 685 "../src/page-view.vala"
	_tmp4_ = page_get_width (_tmp3_);
#line 685 "../src/page-view.vala"
	_tmp5_ = _tmp4_;
#line 685 "../src/page-view.vala"
	pw = _tmp5_;
#line 686 "../src/page-view.vala"
	_tmp6_ = self->priv->_page;
#line 686 "../src/page-view.vala"
	_tmp7_ = page_get_height (_tmp6_);
#line 686 "../src/page-view.vala"
	_tmp8_ = _tmp7_;
#line 686 "../src/page-view.vala"
	ph = _tmp8_;
#line 687 "../src/page-view.vala"
	_tmp9_ = self->priv->_page;
#line 687 "../src/page-view.vala"
	_tmp10_ = page_get_crop_width (_tmp9_);
#line 687 "../src/page-view.vala"
	_tmp11_ = _tmp10_;
#line 687 "../src/page-view.vala"
	cw = _tmp11_;
#line 688 "../src/page-view.vala"
	_tmp12_ = self->priv->_page;
#line 688 "../src/page-view.vala"
	_tmp13_ = page_get_crop_height (_tmp12_);
#line 688 "../src/page-view.vala"
	_tmp14_ = _tmp13_;
#line 688 "../src/page-view.vala"
	ch = _tmp14_;
#line 690 "../src/page-view.vala"
	dx = page_view_screen_to_page_x (self, x - ((gint) self->priv->selected_crop_px));
#line 691 "../src/page-view.vala"
	dy = page_view_screen_to_page_y (self, y - ((gint) self->priv->selected_crop_py));
#line 693 "../src/page-view.vala"
	new_x = self->priv->selected_crop_x;
#line 694 "../src/page-view.vala"
	new_y = self->priv->selected_crop_y;
#line 695 "../src/page-view.vala"
	new_w = self->priv->selected_crop_w;
#line 696 "../src/page-view.vala"
	new_h = self->priv->selected_crop_h;
#line 699 "../src/page-view.vala"
	min_size = page_view_screen_to_page_x (self, 15);
#line 700 "../src/page-view.vala"
	_tmp17_ = self->priv->crop_location;
#line 700 "../src/page-view.vala"
	if (_tmp17_ == CROP_LOCATION_TOP_LEFT) {
#line 700 "../src/page-view.vala"
		_tmp16_ = TRUE;
#line 2705 "page-view.c"
	} else {
		CropLocation _tmp18_;
#line 701 "../src/page-view.vala"
		_tmp18_ = self->priv->crop_location;
#line 701 "../src/page-view.vala"
		_tmp16_ = _tmp18_ == CROP_LOCATION_LEFT;
#line 2712 "page-view.c"
	}
#line 700 "../src/page-view.vala"
	if (_tmp16_) {
#line 700 "../src/page-view.vala"
		_tmp15_ = TRUE;
#line 2718 "page-view.c"
	} else {
		CropLocation _tmp19_;
#line 702 "../src/page-view.vala"
		_tmp19_ = self->priv->crop_location;
#line 702 "../src/page-view.vala"
		_tmp15_ = _tmp19_ == CROP_LOCATION_BOTTOM_LEFT;
#line 2725 "page-view.c"
	}
#line 700 "../src/page-view.vala"
	if (_tmp15_) {
#line 704 "../src/page-view.vala"
		if (dx > (new_w - min_size)) {
#line 705 "../src/page-view.vala"
			dx = new_w - min_size;
#line 2733 "page-view.c"
		}
#line 706 "../src/page-view.vala"
		if ((new_x + dx) < 0) {
#line 707 "../src/page-view.vala"
			dx = -new_x;
#line 2739 "page-view.c"
		}
	}
#line 709 "../src/page-view.vala"
	_tmp22_ = self->priv->crop_location;
#line 709 "../src/page-view.vala"
	if (_tmp22_ == CROP_LOCATION_TOP_LEFT) {
#line 709 "../src/page-view.vala"
		_tmp21_ = TRUE;
#line 2748 "page-view.c"
	} else {
		CropLocation _tmp23_;
#line 710 "../src/page-view.vala"
		_tmp23_ = self->priv->crop_location;
#line 710 "../src/page-view.vala"
		_tmp21_ = _tmp23_ == CROP_LOCATION_TOP;
#line 2755 "page-view.c"
	}
#line 709 "../src/page-view.vala"
	if (_tmp21_) {
#line 709 "../src/page-view.vala"
		_tmp20_ = TRUE;
#line 2761 "page-view.c"
	} else {
		CropLocation _tmp24_;
#line 711 "../src/page-view.vala"
		_tmp24_ = self->priv->crop_location;
#line 711 "../src/page-view.vala"
		_tmp20_ = _tmp24_ == CROP_LOCATION_TOP_RIGHT;
#line 2768 "page-view.c"
	}
#line 709 "../src/page-view.vala"
	if (_tmp20_) {
#line 713 "../src/page-view.vala"
		if (dy > (new_h - min_size)) {
#line 714 "../src/page-view.vala"
			dy = new_h - min_size;
#line 2776 "page-view.c"
		}
#line 715 "../src/page-view.vala"
		if ((new_y + dy) < 0) {
#line 716 "../src/page-view.vala"
			dy = -new_y;
#line 2782 "page-view.c"
		}
	}
#line 719 "../src/page-view.vala"
	_tmp27_ = self->priv->crop_location;
#line 719 "../src/page-view.vala"
	if (_tmp27_ == CROP_LOCATION_TOP_RIGHT) {
#line 719 "../src/page-view.vala"
		_tmp26_ = TRUE;
#line 2791 "page-view.c"
	} else {
		CropLocation _tmp28_;
#line 720 "../src/page-view.vala"
		_tmp28_ = self->priv->crop_location;
#line 720 "../src/page-view.vala"
		_tmp26_ = _tmp28_ == CROP_LOCATION_RIGHT;
#line 2798 "page-view.c"
	}
#line 719 "../src/page-view.vala"
	if (_tmp26_) {
#line 719 "../src/page-view.vala"
		_tmp25_ = TRUE;
#line 2804 "page-view.c"
	} else {
		CropLocation _tmp29_;
#line 721 "../src/page-view.vala"
		_tmp29_ = self->priv->crop_location;
#line 721 "../src/page-view.vala"
		_tmp25_ = _tmp29_ == CROP_LOCATION_BOTTOM_RIGHT;
#line 2811 "page-view.c"
	}
#line 719 "../src/page-view.vala"
	if (_tmp25_) {
#line 723 "../src/page-view.vala"
		if (dx < (min_size - new_w)) {
#line 724 "../src/page-view.vala"
			dx = min_size - new_w;
#line 2819 "page-view.c"
		}
#line 725 "../src/page-view.vala"
		if (((new_x + new_w) + dx) > pw) {
#line 726 "../src/page-view.vala"
			dx = (pw - new_x) - new_w;
#line 2825 "page-view.c"
		}
	}
#line 728 "../src/page-view.vala"
	_tmp32_ = self->priv->crop_location;
#line 728 "../src/page-view.vala"
	if (_tmp32_ == CROP_LOCATION_BOTTOM_LEFT) {
#line 728 "../src/page-view.vala"
		_tmp31_ = TRUE;
#line 2834 "page-view.c"
	} else {
		CropLocation _tmp33_;
#line 729 "../src/page-view.vala"
		_tmp33_ = self->priv->crop_location;
#line 729 "../src/page-view.vala"
		_tmp31_ = _tmp33_ == CROP_LOCATION_BOTTOM;
#line 2841 "page-view.c"
	}
#line 728 "../src/page-view.vala"
	if (_tmp31_) {
#line 728 "../src/page-view.vala"
		_tmp30_ = TRUE;
#line 2847 "page-view.c"
	} else {
		CropLocation _tmp34_;
#line 730 "../src/page-view.vala"
		_tmp34_ = self->priv->crop_location;
#line 730 "../src/page-view.vala"
		_tmp30_ = _tmp34_ == CROP_LOCATION_BOTTOM_RIGHT;
#line 2854 "page-view.c"
	}
#line 728 "../src/page-view.vala"
	if (_tmp30_) {
#line 732 "../src/page-view.vala"
		if (dy < (min_size - new_h)) {
#line 733 "../src/page-view.vala"
			dy = min_size - new_h;
#line 2862 "page-view.c"
		}
#line 734 "../src/page-view.vala"
		if (((new_y + new_h) + dy) > ph) {
#line 735 "../src/page-view.vala"
			dy = (ph - new_y) - new_h;
#line 2868 "page-view.c"
		}
	}
#line 737 "../src/page-view.vala"
	_tmp35_ = self->priv->crop_location;
#line 737 "../src/page-view.vala"
	if (_tmp35_ == CROP_LOCATION_MIDDLE) {
#line 739 "../src/page-view.vala"
		if (((new_x + dx) + new_w) > pw) {
#line 740 "../src/page-view.vala"
			dx = (pw - new_x) - new_w;
#line 2879 "page-view.c"
		}
#line 741 "../src/page-view.vala"
		if ((new_x + dx) < 0) {
#line 742 "../src/page-view.vala"
			dx = -new_x;
#line 2885 "page-view.c"
		}
#line 743 "../src/page-view.vala"
		if (((new_y + dy) + new_h) > ph) {
#line 744 "../src/page-view.vala"
			dy = (ph - new_y) - new_h;
#line 2891 "page-view.c"
		}
#line 745 "../src/page-view.vala"
		if ((new_y + dy) < 0) {
#line 746 "../src/page-view.vala"
			dy = -new_y;
#line 2897 "page-view.c"
		}
	}
#line 750 "../src/page-view.vala"
	_tmp36_ = self->priv->crop_location;
#line 750 "../src/page-view.vala"
	if (_tmp36_ == CROP_LOCATION_MIDDLE) {
#line 752 "../src/page-view.vala"
		new_x += dx;
#line 753 "../src/page-view.vala"
		new_y += dy;
#line 2908 "page-view.c"
	}
#line 755 "../src/page-view.vala"
	_tmp39_ = self->priv->crop_location;
#line 755 "../src/page-view.vala"
	if (_tmp39_ == CROP_LOCATION_TOP_LEFT) {
#line 755 "../src/page-view.vala"
		_tmp38_ = TRUE;
#line 2916 "page-view.c"
	} else {
		CropLocation _tmp40_;
#line 756 "../src/page-view.vala"
		_tmp40_ = self->priv->crop_location;
#line 756 "../src/page-view.vala"
		_tmp38_ = _tmp40_ == CROP_LOCATION_LEFT;
#line 2923 "page-view.c"
	}
#line 755 "../src/page-view.vala"
	if (_tmp38_) {
#line 755 "../src/page-view.vala"
		_tmp37_ = TRUE;
#line 2929 "page-view.c"
	} else {
		CropLocation _tmp41_;
#line 757 "../src/page-view.vala"
		_tmp41_ = self->priv->crop_location;
#line 757 "../src/page-view.vala"
		_tmp37_ = _tmp41_ == CROP_LOCATION_BOTTOM_LEFT;
#line 2936 "page-view.c"
	}
#line 755 "../src/page-view.vala"
	if (_tmp37_) {
#line 759 "../src/page-view.vala"
		new_x += dx;
#line 760 "../src/page-view.vala"
		new_w -= dx;
#line 2944 "page-view.c"
	}
#line 762 "../src/page-view.vala"
	_tmp44_ = self->priv->crop_location;
#line 762 "../src/page-view.vala"
	if (_tmp44_ == CROP_LOCATION_TOP_LEFT) {
#line 762 "../src/page-view.vala"
		_tmp43_ = TRUE;
#line 2952 "page-view.c"
	} else {
		CropLocation _tmp45_;
#line 763 "../src/page-view.vala"
		_tmp45_ = self->priv->crop_location;
#line 763 "../src/page-view.vala"
		_tmp43_ = _tmp45_ == CROP_LOCATION_TOP;
#line 2959 "page-view.c"
	}
#line 762 "../src/page-view.vala"
	if (_tmp43_) {
#line 762 "../src/page-view.vala"
		_tmp42_ = TRUE;
#line 2965 "page-view.c"
	} else {
		CropLocation _tmp46_;
#line 764 "../src/page-view.vala"
		_tmp46_ = self->priv->crop_location;
#line 764 "../src/page-view.vala"
		_tmp42_ = _tmp46_ == CROP_LOCATION_TOP_RIGHT;
#line 2972 "page-view.c"
	}
#line 762 "../src/page-view.vala"
	if (_tmp42_) {
#line 766 "../src/page-view.vala"
		new_y += dy;
#line 767 "../src/page-view.vala"
		new_h -= dy;
#line 2980 "page-view.c"
	}
#line 770 "../src/page-view.vala"
	_tmp49_ = self->priv->crop_location;
#line 770 "../src/page-view.vala"
	if (_tmp49_ == CROP_LOCATION_TOP_RIGHT) {
#line 770 "../src/page-view.vala"
		_tmp48_ = TRUE;
#line 2988 "page-view.c"
	} else {
		CropLocation _tmp50_;
#line 771 "../src/page-view.vala"
		_tmp50_ = self->priv->crop_location;
#line 771 "../src/page-view.vala"
		_tmp48_ = _tmp50_ == CROP_LOCATION_RIGHT;
#line 2995 "page-view.c"
	}
#line 770 "../src/page-view.vala"
	if (_tmp48_) {
#line 770 "../src/page-view.vala"
		_tmp47_ = TRUE;
#line 3001 "page-view.c"
	} else {
		CropLocation _tmp51_;
#line 772 "../src/page-view.vala"
		_tmp51_ = self->priv->crop_location;
#line 772 "../src/page-view.vala"
		_tmp47_ = _tmp51_ == CROP_LOCATION_BOTTOM_RIGHT;
#line 3008 "page-view.c"
	}
#line 770 "../src/page-view.vala"
	if (_tmp47_) {
#line 773 "../src/page-view.vala"
		new_w += dx;
#line 3014 "page-view.c"
	}
#line 774 "../src/page-view.vala"
	_tmp54_ = self->priv->crop_location;
#line 774 "../src/page-view.vala"
	if (_tmp54_ == CROP_LOCATION_BOTTOM_LEFT) {
#line 774 "../src/page-view.vala"
		_tmp53_ = TRUE;
#line 3022 "page-view.c"
	} else {
		CropLocation _tmp55_;
#line 775 "../src/page-view.vala"
		_tmp55_ = self->priv->crop_location;
#line 775 "../src/page-view.vala"
		_tmp53_ = _tmp55_ == CROP_LOCATION_BOTTOM;
#line 3029 "page-view.c"
	}
#line 774 "../src/page-view.vala"
	if (_tmp53_) {
#line 774 "../src/page-view.vala"
		_tmp52_ = TRUE;
#line 3035 "page-view.c"
	} else {
		CropLocation _tmp56_;
#line 776 "../src/page-view.vala"
		_tmp56_ = self->priv->crop_location;
#line 776 "../src/page-view.vala"
		_tmp52_ = _tmp56_ == CROP_LOCATION_BOTTOM_RIGHT;
#line 3042 "page-view.c"
	}
#line 774 "../src/page-view.vala"
	if (_tmp52_) {
#line 777 "../src/page-view.vala"
		new_h += dy;
#line 3048 "page-view.c"
	}
#line 779 "../src/page-view.vala"
	_tmp57_ = self->priv->_page;
#line 779 "../src/page-view.vala"
	page_move_crop (_tmp57_, new_x, new_y);
#line 782 "../src/page-view.vala"
	if (new_w != cw) {
#line 782 "../src/page-view.vala"
		_tmp58_ = TRUE;
#line 3058 "page-view.c"
	} else {
#line 782 "../src/page-view.vala"
		_tmp58_ = new_h != ch;
#line 3062 "page-view.c"
	}
#line 782 "../src/page-view.vala"
	if (_tmp58_) {
#line 3066 "page-view.c"
		Page* _tmp59_;
#line 783 "../src/page-view.vala"
		_tmp59_ = self->priv->_page;
#line 783 "../src/page-view.vala"
		page_set_custom_crop (_tmp59_, new_w, new_h);
#line 3072 "page-view.c"
	}
}

void
page_view_button_release (PageView* self,
                          gint x,
                          gint y)
{
#line 786 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 789 "../src/page-view.vala"
	self->priv->crop_location = CROP_LOCATION_NONE;
#line 790 "../src/page-view.vala"
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
#line 3087 "page-view.c"
}

static gboolean
page_view_animation_cb (PageView* self)
{
	gboolean result = FALSE;
#line 793 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 795 "../src/page-view.vala"
	self->priv->animate_segment = (self->priv->animate_segment + 1) % self->priv->animate_n_segments;
#line 796 "../src/page-view.vala"
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
#line 797 "../src/page-view.vala"
	result = TRUE;
#line 797 "../src/page-view.vala"
	return result;
#line 3104 "page-view.c"
}

static gboolean
_page_view_animation_cb_gsource_func (gpointer self)
{
	gboolean result;
	result = page_view_animation_cb ((PageView*) self);
#line 813 "../src/page-view.vala"
	return result;
#line 3114 "page-view.c"
}

static void
page_view_update_animation (PageView* self)
{
	gboolean animate = FALSE;
	gboolean is_animating = FALSE;
	gboolean _tmp0_ = FALSE;
	Page* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 800 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 804 "../src/page-view.vala"
	_tmp1_ = self->priv->_page;
#line 804 "../src/page-view.vala"
	_tmp2_ = page_get_is_scanning (_tmp1_);
#line 804 "../src/page-view.vala"
	_tmp3_ = _tmp2_;
#line 804 "../src/page-view.vala"
	if (_tmp3_) {
#line 3136 "page-view.c"
		Page* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
#line 804 "../src/page-view.vala"
		_tmp4_ = self->priv->_page;
#line 804 "../src/page-view.vala"
		_tmp5_ = page_get_has_data (_tmp4_);
#line 804 "../src/page-view.vala"
		_tmp6_ = _tmp5_;
#line 804 "../src/page-view.vala"
		_tmp0_ = !_tmp6_;
#line 3148 "page-view.c"
	} else {
#line 804 "../src/page-view.vala"
		_tmp0_ = FALSE;
#line 3152 "page-view.c"
	}
#line 804 "../src/page-view.vala"
	animate = _tmp0_;
#line 805 "../src/page-view.vala"
	is_animating = self->priv->animate_timeout != ((guint) 0);
#line 806 "../src/page-view.vala"
	if (animate == is_animating) {
#line 807 "../src/page-view.vala"
		return;
#line 3162 "page-view.c"
	}
#line 809 "../src/page-view.vala"
	if (animate) {
#line 811 "../src/page-view.vala"
		self->priv->animate_segment = 0;
#line 812 "../src/page-view.vala"
		if (self->priv->animate_timeout == ((guint) 0)) {
#line 813 "../src/page-view.vala"
			self->priv->animate_timeout = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 150, _page_view_animation_cb_gsource_func, g_object_ref (self), g_object_unref);
#line 3172 "page-view.c"
		}
	} else {
#line 817 "../src/page-view.vala"
		if (self->priv->animate_timeout != ((guint) 0)) {
#line 818 "../src/page-view.vala"
			g_source_remove (self->priv->animate_timeout);
#line 3179 "page-view.c"
		}
#line 819 "../src/page-view.vala"
		self->priv->animate_timeout = (guint) 0;
#line 3183 "page-view.c"
	}
}

void
page_view_render (PageView* self,
                  cairo_t* context)
{
	gint w = 0;
	gint h = 0;
	gint _tmp0_;
	gint _tmp1_;
	GdkPixbuf* _tmp2_;
	gboolean _tmp3_ = FALSE;
	Page* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp12_ = FALSE;
	Page* _tmp13_;
	gboolean _tmp14_;
	gboolean _tmp15_;
	Page* _tmp25_;
	gboolean _tmp26_;
	gboolean _tmp27_;
#line 823 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 823 "../src/page-view.vala"
	g_return_if_fail (context != NULL);
#line 825 "../src/page-view.vala"
	page_view_update_animation (self);
#line 826 "../src/page-view.vala"
	page_view_update_page_view (self);
#line 828 "../src/page-view.vala"
	w = page_view_get_preview_width (self);
#line 829 "../src/page-view.vala"
	h = page_view_get_preview_height (self);
#line 831 "../src/page-view.vala"
	cairo_set_line_width (context, (gdouble) 1);
#line 832 "../src/page-view.vala"
	_tmp0_ = self->priv->_x_offset;
#line 832 "../src/page-view.vala"
	_tmp1_ = self->priv->_y_offset;
#line 832 "../src/page-view.vala"
	cairo_translate (context, (gdouble) _tmp0_, (gdouble) _tmp1_);
#line 835 "../src/page-view.vala"
	cairo_set_source_rgb (context, (gdouble) 0, (gdouble) 0, (gdouble) 0);
#line 836 "../src/page-view.vala"
	cairo_set_line_width (context, (gdouble) self->priv->border_width);
#line 837 "../src/page-view.vala"
	cairo_rectangle (context, ((gdouble) self->priv->border_width) / 2, ((gdouble) self->priv->border_width) / 2, (gdouble) (self->priv->width_ - self->priv->border_width), (gdouble) (self->priv->height_ - self->priv->border_width));
#line 841 "../src/page-view.vala"
	cairo_stroke (context);
#line 844 "../src/page-view.vala"
	cairo_translate (context, (gdouble) self->priv->border_width, (gdouble) self->priv->border_width);
#line 845 "../src/page-view.vala"
	_tmp2_ = self->priv->image;
#line 845 "../src/page-view.vala"
	gdk_cairo_set_source_pixbuf (context, _tmp2_, (gdouble) 0, (gdouble) 0);
#line 846 "../src/page-view.vala"
	cairo_paint (context);
#line 849 "../src/page-view.vala"
	_tmp4_ = self->priv->_page;
#line 849 "../src/page-view.vala"
	_tmp5_ = page_get_is_scanning (_tmp4_);
#line 849 "../src/page-view.vala"
	_tmp6_ = _tmp5_;
#line 849 "../src/page-view.vala"
	if (_tmp6_) {
#line 3251 "page-view.c"
		Page* _tmp7_;
		gboolean _tmp8_;
		gboolean _tmp9_;
#line 849 "../src/page-view.vala"
		_tmp7_ = self->priv->_page;
#line 849 "../src/page-view.vala"
		_tmp8_ = page_get_has_data (_tmp7_);
#line 849 "../src/page-view.vala"
		_tmp9_ = _tmp8_;
#line 849 "../src/page-view.vala"
		_tmp3_ = !_tmp9_;
#line 3263 "page-view.c"
	} else {
#line 849 "../src/page-view.vala"
		_tmp3_ = FALSE;
#line 3267 "page-view.c"
	}
#line 849 "../src/page-view.vala"
	if (_tmp3_) {
#line 3271 "page-view.c"
		gdouble outer_radius = 0.0;
		gdouble arc = 0.0;
		gdouble x = 0.0;
		gdouble y = 0.0;
		gdouble inner_radius = 0.0;
		gdouble offset = 0.0;
#line 852 "../src/page-view.vala"
		if (w > h) {
#line 853 "../src/page-view.vala"
			outer_radius = 0.15 * w;
#line 3282 "page-view.c"
		} else {
#line 855 "../src/page-view.vala"
			outer_radius = 0.15 * h;
#line 3286 "page-view.c"
		}
#line 856 "../src/page-view.vala"
		arc = G_PI / self->priv->animate_n_segments;
#line 859 "../src/page-view.vala"
		x = outer_radius * sin (arc);
#line 860 "../src/page-view.vala"
		y = outer_radius * (cos (arc) - 1.0);
#line 861 "../src/page-view.vala"
		inner_radius = 0.6 * sqrt ((x * x) + (y * y));
#line 863 "../src/page-view.vala"
		offset = 0.0;
#line 3298 "page-view.c"
		{
			gint i = 0;
#line 864 "../src/page-view.vala"
			i = 0;
#line 3303 "page-view.c"
			{
				gboolean _tmp10_ = FALSE;
#line 864 "../src/page-view.vala"
				_tmp10_ = TRUE;
#line 864 "../src/page-view.vala"
				while (TRUE) {
#line 864 "../src/page-view.vala"
					if (!_tmp10_) {
#line 3312 "page-view.c"
						gint _tmp11_;
#line 864 "../src/page-view.vala"
						_tmp11_ = i;
#line 864 "../src/page-view.vala"
						i = _tmp11_ + 1;
#line 864 "../src/page-view.vala"
						offset += arc * 2;
#line 3320 "page-view.c"
					}
#line 864 "../src/page-view.vala"
					_tmp10_ = FALSE;
#line 864 "../src/page-view.vala"
					if (!(i < self->priv->animate_n_segments)) {
#line 864 "../src/page-view.vala"
						break;
#line 3328 "page-view.c"
					}
#line 866 "../src/page-view.vala"
					x = (w / 2) + (outer_radius * sin (offset));
#line 867 "../src/page-view.vala"
					y = (h / 2) - (outer_radius * cos (offset));
#line 868 "../src/page-view.vala"
					cairo_arc (context, x, y, inner_radius, (gdouble) 0, 2 * G_PI);
#line 870 "../src/page-view.vala"
					if (i == self->priv->animate_segment) {
#line 872 "../src/page-view.vala"
						cairo_set_source_rgb (context, 0.75, 0.75, 0.75);
#line 873 "../src/page-view.vala"
						cairo_fill_preserve (context);
#line 3342 "page-view.c"
					}
#line 876 "../src/page-view.vala"
					cairo_set_source_rgb (context, 0.5, 0.5, 0.5);
#line 877 "../src/page-view.vala"
					cairo_stroke (context);
#line 3348 "page-view.c"
				}
			}
		}
	}
#line 882 "../src/page-view.vala"
	_tmp13_ = self->priv->_page;
#line 882 "../src/page-view.vala"
	_tmp14_ = page_get_is_scanning (_tmp13_);
#line 882 "../src/page-view.vala"
	_tmp15_ = _tmp14_;
#line 882 "../src/page-view.vala"
	if (_tmp15_) {
#line 3361 "page-view.c"
		Page* _tmp16_;
		gint _tmp17_;
		gint _tmp18_;
#line 882 "../src/page-view.vala"
		_tmp16_ = self->priv->_page;
#line 882 "../src/page-view.vala"
		_tmp17_ = page_get_scan_line (_tmp16_);
#line 882 "../src/page-view.vala"
		_tmp18_ = _tmp17_;
#line 882 "../src/page-view.vala"
		_tmp12_ = _tmp18_ > 0;
#line 3373 "page-view.c"
	} else {
#line 882 "../src/page-view.vala"
		_tmp12_ = FALSE;
#line 3377 "page-view.c"
	}
#line 882 "../src/page-view.vala"
	if (_tmp12_) {
#line 3381 "page-view.c"
		gint scan_line = 0;
		Page* _tmp19_;
		gint _tmp20_;
		gint _tmp21_;
		gdouble s = 0.0;
		gdouble x1 = 0.0;
		gdouble y1 = 0.0;
		gdouble x2 = 0.0;
		gdouble y2 = 0.0;
		Page* _tmp22_;
		ScanDirection _tmp23_;
		ScanDirection _tmp24_;
#line 884 "../src/page-view.vala"
		_tmp19_ = self->priv->_page;
#line 884 "../src/page-view.vala"
		_tmp20_ = page_get_scan_line (_tmp19_);
#line 884 "../src/page-view.vala"
		_tmp21_ = _tmp20_;
#line 884 "../src/page-view.vala"
		scan_line = _tmp21_;
#line 888 "../src/page-view.vala"
		_tmp22_ = self->priv->_page;
#line 888 "../src/page-view.vala"
		_tmp23_ = page_get_scan_direction (_tmp22_);
#line 888 "../src/page-view.vala"
		_tmp24_ = _tmp23_;
#line 888 "../src/page-view.vala"
		switch (_tmp24_) {
#line 888 "../src/page-view.vala"
			case SCAN_DIRECTION_TOP_TO_BOTTOM:
#line 3412 "page-view.c"
			{
#line 891 "../src/page-view.vala"
				s = (gdouble) page_view_page_to_screen_y (self, scan_line);
#line 892 "../src/page-view.vala"
				x1 = (gdouble) 0;
#line 892 "../src/page-view.vala"
				y1 = s + 0.5;
#line 893 "../src/page-view.vala"
				x2 = (gdouble) w;
#line 893 "../src/page-view.vala"
				y2 = s + 0.5;
#line 894 "../src/page-view.vala"
				break;
#line 3426 "page-view.c"
			}
#line 888 "../src/page-view.vala"
			case SCAN_DIRECTION_BOTTOM_TO_TOP:
#line 3430 "page-view.c"
			{
#line 896 "../src/page-view.vala"
				s = (gdouble) page_view_page_to_screen_y (self, scan_line);
#line 897 "../src/page-view.vala"
				x1 = (gdouble) 0;
#line 897 "../src/page-view.vala"
				y1 = (h - s) + 0.5;
#line 898 "../src/page-view.vala"
				x2 = (gdouble) w;
#line 898 "../src/page-view.vala"
				y2 = (h - s) + 0.5;
#line 899 "../src/page-view.vala"
				break;
#line 3444 "page-view.c"
			}
#line 888 "../src/page-view.vala"
			case SCAN_DIRECTION_LEFT_TO_RIGHT:
#line 3448 "page-view.c"
			{
#line 901 "../src/page-view.vala"
				s = (gdouble) page_view_page_to_screen_x (self, scan_line);
#line 902 "../src/page-view.vala"
				x1 = s + 0.5;
#line 902 "../src/page-view.vala"
				y1 = (gdouble) 0;
#line 903 "../src/page-view.vala"
				x2 = s + 0.5;
#line 903 "../src/page-view.vala"
				y2 = (gdouble) h;
#line 904 "../src/page-view.vala"
				break;
#line 3462 "page-view.c"
			}
#line 888 "../src/page-view.vala"
			case SCAN_DIRECTION_RIGHT_TO_LEFT:
#line 3466 "page-view.c"
			{
#line 906 "../src/page-view.vala"
				s = (gdouble) page_view_page_to_screen_x (self, scan_line);
#line 907 "../src/page-view.vala"
				x1 = (w - s) + 0.5;
#line 907 "../src/page-view.vala"
				y1 = (gdouble) 0;
#line 908 "../src/page-view.vala"
				x2 = (w - s) + 0.5;
#line 908 "../src/page-view.vala"
				y2 = (gdouble) h;
#line 909 "../src/page-view.vala"
				break;
#line 3480 "page-view.c"
			}
			default:
			{
#line 911 "../src/page-view.vala"
				y2 = (gdouble) 0;
#line 911 "../src/page-view.vala"
				x2 = y2;
#line 911 "../src/page-view.vala"
				y1 = x2;
#line 911 "../src/page-view.vala"
				x1 = y1;
#line 912 "../src/page-view.vala"
				break;
#line 3494 "page-view.c"
			}
		}
#line 915 "../src/page-view.vala"
		cairo_move_to (context, x1, y1);
#line 916 "../src/page-view.vala"
		cairo_line_to (context, x2, y2);
#line 917 "../src/page-view.vala"
		cairo_set_source_rgb (context, 1.0, 0.0, 0.0);
#line 918 "../src/page-view.vala"
		cairo_stroke (context);
#line 3505 "page-view.c"
	}
#line 922 "../src/page-view.vala"
	_tmp25_ = self->priv->_page;
#line 922 "../src/page-view.vala"
	_tmp26_ = page_get_has_crop (_tmp25_);
#line 922 "../src/page-view.vala"
	_tmp27_ = _tmp26_;
#line 922 "../src/page-view.vala"
	if (_tmp27_) {
#line 3515 "page-view.c"
		gint x = 0;
		Page* _tmp28_;
		gint _tmp29_;
		gint _tmp30_;
		gint y = 0;
		Page* _tmp31_;
		gint _tmp32_;
		gint _tmp33_;
		gint crop_width = 0;
		Page* _tmp34_;
		gint _tmp35_;
		gint _tmp36_;
		gint crop_height = 0;
		Page* _tmp37_;
		gint _tmp38_;
		gint _tmp39_;
		gint dx = 0;
		gint dy = 0;
		gint dw = 0;
		gint dh = 0;
#line 924 "../src/page-view.vala"
		_tmp28_ = self->priv->_page;
#line 924 "../src/page-view.vala"
		_tmp29_ = page_get_crop_x (_tmp28_);
#line 924 "../src/page-view.vala"
		_tmp30_ = _tmp29_;
#line 924 "../src/page-view.vala"
		x = _tmp30_;
#line 925 "../src/page-view.vala"
		_tmp31_ = self->priv->_page;
#line 925 "../src/page-view.vala"
		_tmp32_ = page_get_crop_y (_tmp31_);
#line 925 "../src/page-view.vala"
		_tmp33_ = _tmp32_;
#line 925 "../src/page-view.vala"
		y = _tmp33_;
#line 926 "../src/page-view.vala"
		_tmp34_ = self->priv->_page;
#line 926 "../src/page-view.vala"
		_tmp35_ = page_get_crop_width (_tmp34_);
#line 926 "../src/page-view.vala"
		_tmp36_ = _tmp35_;
#line 926 "../src/page-view.vala"
		crop_width = _tmp36_;
#line 927 "../src/page-view.vala"
		_tmp37_ = self->priv->_page;
#line 927 "../src/page-view.vala"
		_tmp38_ = page_get_crop_height (_tmp37_);
#line 927 "../src/page-view.vala"
		_tmp39_ = _tmp38_;
#line 927 "../src/page-view.vala"
		crop_height = _tmp39_;
#line 929 "../src/page-view.vala"
		dx = page_view_page_to_screen_x (self, x);
#line 930 "../src/page-view.vala"
		dy = page_view_page_to_screen_y (self, y);
#line 931 "../src/page-view.vala"
		dw = page_view_page_to_screen_x (self, crop_width);
#line 932 "../src/page-view.vala"
		dh = page_view_page_to_screen_y (self, crop_height);
#line 935 "../src/page-view.vala"
		cairo_rectangle (context, (gdouble) 0, (gdouble) 0, (gdouble) w, (gdouble) h);
#line 936 "../src/page-view.vala"
		cairo_new_sub_path (context);
#line 937 "../src/page-view.vala"
		cairo_rectangle (context, (gdouble) dx, (gdouble) dy, (gdouble) dw, (gdouble) dh);
#line 938 "../src/page-view.vala"
		cairo_set_fill_rule (context, CAIRO_FILL_RULE_EVEN_ODD);
#line 939 "../src/page-view.vala"
		cairo_set_source_rgba (context, 0.25, 0.25, 0.25, 0.2);
#line 940 "../src/page-view.vala"
		cairo_fill (context);
#line 943 "../src/page-view.vala"
		cairo_rectangle (context, dx - 1.5, dy - 1.5, (gdouble) (dw + 3), (gdouble) (dh + 3));
#line 944 "../src/page-view.vala"
		cairo_set_source_rgb (context, 1.0, 1.0, 1.0);
#line 945 "../src/page-view.vala"
		cairo_stroke (context);
#line 946 "../src/page-view.vala"
		cairo_rectangle (context, dx - 0.5, dy - 0.5, (gdouble) (dw + 1), (gdouble) (dh + 1));
#line 947 "../src/page-view.vala"
		cairo_set_source_rgb (context, 0.0, 0.0, 0.0);
#line 948 "../src/page-view.vala"
		cairo_stroke (context);
#line 3600 "page-view.c"
	}
}

static void
page_view_page_pixels_changed_cb (PageView* self,
                                  Page* p)
{
#line 994 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 994 "../src/page-view.vala"
	g_return_if_fail (p != NULL);
#line 997 "../src/page-view.vala"
	self->priv->update_image = TRUE;
#line 998 "../src/page-view.vala"
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
#line 3616 "page-view.c"
}

static void
page_view_page_size_changed_cb (PageView* self,
                                Page* p)
{
#line 1001 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 1001 "../src/page-view.vala"
	g_return_if_fail (p != NULL);
#line 1004 "../src/page-view.vala"
	self->priv->update_image = TRUE;
#line 1005 "../src/page-view.vala"
	g_signal_emit (self, page_view_signals[PAGE_VIEW_SIZE_CHANGED_SIGNAL], 0);
#line 1006 "../src/page-view.vala"
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
#line 3633 "page-view.c"
}

static void
page_view_page_overlay_changed_cb (PageView* self,
                                   Page* p)
{
#line 1009 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 1009 "../src/page-view.vala"
	g_return_if_fail (p != NULL);
#line 1011 "../src/page-view.vala"
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
#line 3646 "page-view.c"
}

static void
page_view_scan_direction_changed_cb (PageView* self,
                                     Page* p)
{
#line 1014 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 1014 "../src/page-view.vala"
	g_return_if_fail (p != NULL);
#line 1017 "../src/page-view.vala"
	self->priv->update_image = TRUE;
#line 1018 "../src/page-view.vala"
	g_signal_emit (self, page_view_signals[PAGE_VIEW_SIZE_CHANGED_SIGNAL], 0);
#line 1019 "../src/page-view.vala"
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
#line 3663 "page-view.c"
}

Page*
page_view_get_page (PageView* self)
{
	Page* result;
	Page* _tmp0_;
#line 29 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 29 "../src/page-view.vala"
	_tmp0_ = self->priv->_page;
#line 29 "../src/page-view.vala"
	result = _tmp0_;
#line 29 "../src/page-view.vala"
	return result;
#line 3679 "page-view.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 29 "../src/page-view.vala"
	return self ? g_object_ref (self) : NULL;
#line 3687 "page-view.c"
}

static void
page_view_set_page (PageView* self,
                    Page* value)
{
#line 29 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/page-view.vala"
	if (page_view_get_page (self) != value) {
#line 3698 "page-view.c"
		Page* _tmp0_;
#line 29 "../src/page-view.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 29 "../src/page-view.vala"
		_g_object_unref0 (self->priv->_page);
#line 29 "../src/page-view.vala"
		self->priv->_page = _tmp0_;
#line 29 "../src/page-view.vala"
		g_object_notify_by_pspec ((GObject *) self, page_view_properties[PAGE_VIEW_PAGE_PROPERTY]);
#line 3708 "page-view.c"
	}
}

gboolean
page_view_get_selected (PageView* self)
{
	gboolean result;
#line 38 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 38 "../src/page-view.vala"
	result = self->priv->selected_;
#line 38 "../src/page-view.vala"
	return result;
#line 3722 "page-view.c"
}

void
page_view_set_selected (PageView* self,
                        gboolean value)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp11_;
	gboolean _tmp12_;
#line 39 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 41 "../src/page-view.vala"
	_tmp2_ = page_view_get_selected (self);
#line 41 "../src/page-view.vala"
	_tmp3_ = _tmp2_;
#line 41 "../src/page-view.vala"
	if (_tmp3_) {
#line 3743 "page-view.c"
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 41 "../src/page-view.vala"
		_tmp4_ = page_view_get_selected (self);
#line 41 "../src/page-view.vala"
		_tmp5_ = _tmp4_;
#line 41 "../src/page-view.vala"
		_tmp1_ = _tmp5_;
#line 3752 "page-view.c"
	} else {
#line 41 "../src/page-view.vala"
		_tmp1_ = FALSE;
#line 3756 "page-view.c"
	}
#line 41 "../src/page-view.vala"
	if (_tmp1_) {
#line 41 "../src/page-view.vala"
		_tmp0_ = TRUE;
#line 3762 "page-view.c"
	} else {
		gboolean _tmp6_ = FALSE;
		gboolean _tmp7_;
		gboolean _tmp8_;
#line 41 "../src/page-view.vala"
		_tmp7_ = page_view_get_selected (self);
#line 41 "../src/page-view.vala"
		_tmp8_ = _tmp7_;
#line 41 "../src/page-view.vala"
		if (!_tmp8_) {
#line 3773 "page-view.c"
			gboolean _tmp9_;
			gboolean _tmp10_;
#line 41 "../src/page-view.vala"
			_tmp9_ = page_view_get_selected (self);
#line 41 "../src/page-view.vala"
			_tmp10_ = _tmp9_;
#line 41 "../src/page-view.vala"
			_tmp6_ = !_tmp10_;
#line 3782 "page-view.c"
		} else {
#line 41 "../src/page-view.vala"
			_tmp6_ = FALSE;
#line 3786 "page-view.c"
		}
#line 41 "../src/page-view.vala"
		_tmp0_ = _tmp6_;
#line 3790 "page-view.c"
	}
#line 41 "../src/page-view.vala"
	if (_tmp0_) {
#line 42 "../src/page-view.vala"
		return;
#line 3796 "page-view.c"
	}
#line 43 "../src/page-view.vala"
	_tmp11_ = page_view_get_selected (self);
#line 43 "../src/page-view.vala"
	_tmp12_ = _tmp11_;
#line 43 "../src/page-view.vala"
	page_view_set_selected (self, _tmp12_);
#line 44 "../src/page-view.vala"
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
#line 39 "../src/page-view.vala"
	g_object_notify_by_pspec ((GObject *) self, page_view_properties[PAGE_VIEW_SELECTED_PROPERTY]);
#line 3808 "page-view.c"
}

gint
page_view_get_x_offset (PageView* self)
{
	gint result;
#line 64 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 64 "../src/page-view.vala"
	result = self->priv->_x_offset;
#line 64 "../src/page-view.vala"
	return result;
#line 3821 "page-view.c"
}

void
page_view_set_x_offset (PageView* self,
                        gint value)
{
#line 64 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 64 "../src/page-view.vala"
	if (page_view_get_x_offset (self) != value) {
#line 64 "../src/page-view.vala"
		self->priv->_x_offset = value;
#line 64 "../src/page-view.vala"
		g_object_notify_by_pspec ((GObject *) self, page_view_properties[PAGE_VIEW_X_OFFSET_PROPERTY]);
#line 3836 "page-view.c"
	}
}

gint
page_view_get_y_offset (PageView* self)
{
	gint result;
#line 65 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 65 "../src/page-view.vala"
	result = self->priv->_y_offset;
#line 65 "../src/page-view.vala"
	return result;
#line 3850 "page-view.c"
}

void
page_view_set_y_offset (PageView* self,
                        gint value)
{
#line 65 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 65 "../src/page-view.vala"
	if (page_view_get_y_offset (self) != value) {
#line 65 "../src/page-view.vala"
		self->priv->_y_offset = value;
#line 65 "../src/page-view.vala"
		g_object_notify_by_pspec ((GObject *) self, page_view_properties[PAGE_VIEW_Y_OFFSET_PROPERTY]);
#line 3865 "page-view.c"
	}
}

GdkCursorType
page_view_get_cursor (PageView* self)
{
	GdkCursorType result;
	GdkCursorType _tmp0_;
#line 76 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 76 "../src/page-view.vala"
	_tmp0_ = self->priv->_cursor;
#line 76 "../src/page-view.vala"
	result = _tmp0_;
#line 76 "../src/page-view.vala"
	return result;
#line 3882 "page-view.c"
}

static void
page_view_set_cursor (PageView* self,
                      GdkCursorType value)
{
#line 76 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 76 "../src/page-view.vala"
	if (page_view_get_cursor (self) != value) {
#line 76 "../src/page-view.vala"
		self->priv->_cursor = value;
#line 76 "../src/page-view.vala"
		g_object_notify_by_pspec ((GObject *) self, page_view_properties[PAGE_VIEW_CURSOR_PROPERTY]);
#line 3897 "page-view.c"
	}
}

gint
page_view_get_width (PageView* self)
{
	gint result;
#line 954 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 954 "../src/page-view.vala"
	result = self->priv->width_;
#line 954 "../src/page-view.vala"
	return result;
#line 3911 "page-view.c"
}

void
page_view_set_width (PageView* self,
                     gint value)
{
	gint h = 0;
	Page* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	Page* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gboolean _tmp6_ = FALSE;
#line 955 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 958 "../src/page-view.vala"
	_tmp0_ = self->priv->_page;
#line 958 "../src/page-view.vala"
	_tmp1_ = page_get_height (_tmp0_);
#line 958 "../src/page-view.vala"
	_tmp2_ = _tmp1_;
#line 958 "../src/page-view.vala"
	_tmp3_ = self->priv->_page;
#line 958 "../src/page-view.vala"
	_tmp4_ = page_get_width (_tmp3_);
#line 958 "../src/page-view.vala"
	_tmp5_ = _tmp4_;
#line 958 "../src/page-view.vala"
	h = (gint) ((((gdouble) value) * _tmp2_) / _tmp5_);
#line 959 "../src/page-view.vala"
	if (self->priv->width_ == value) {
#line 959 "../src/page-view.vala"
		_tmp6_ = self->priv->height_ == h;
#line 3946 "page-view.c"
	} else {
#line 959 "../src/page-view.vala"
		_tmp6_ = FALSE;
#line 3950 "page-view.c"
	}
#line 959 "../src/page-view.vala"
	if (_tmp6_) {
#line 960 "../src/page-view.vala"
		return;
#line 3956 "page-view.c"
	}
#line 962 "../src/page-view.vala"
	self->priv->width_ = value;
#line 963 "../src/page-view.vala"
	self->priv->height_ = h;
#line 966 "../src/page-view.vala"
	self->priv->update_image = TRUE;
#line 968 "../src/page-view.vala"
	g_signal_emit (self, page_view_signals[PAGE_VIEW_SIZE_CHANGED_SIGNAL], 0);
#line 969 "../src/page-view.vala"
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
#line 955 "../src/page-view.vala"
	g_object_notify_by_pspec ((GObject *) self, page_view_properties[PAGE_VIEW_WIDTH_PROPERTY]);
#line 3970 "page-view.c"
}

gint
page_view_get_height (PageView* self)
{
	gint result;
#line 975 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 975 "../src/page-view.vala"
	result = self->priv->height_;
#line 975 "../src/page-view.vala"
	return result;
#line 3983 "page-view.c"
}

void
page_view_set_height (PageView* self,
                      gint value)
{
	gint w = 0;
	Page* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	Page* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gboolean _tmp6_ = FALSE;
#line 976 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 979 "../src/page-view.vala"
	_tmp0_ = self->priv->_page;
#line 979 "../src/page-view.vala"
	_tmp1_ = page_get_width (_tmp0_);
#line 979 "../src/page-view.vala"
	_tmp2_ = _tmp1_;
#line 979 "../src/page-view.vala"
	_tmp3_ = self->priv->_page;
#line 979 "../src/page-view.vala"
	_tmp4_ = page_get_height (_tmp3_);
#line 979 "../src/page-view.vala"
	_tmp5_ = _tmp4_;
#line 979 "../src/page-view.vala"
	w = (gint) ((((gdouble) value) * _tmp2_) / _tmp5_);
#line 980 "../src/page-view.vala"
	if (self->priv->width_ == w) {
#line 980 "../src/page-view.vala"
		_tmp6_ = self->priv->height_ == value;
#line 4018 "page-view.c"
	} else {
#line 980 "../src/page-view.vala"
		_tmp6_ = FALSE;
#line 4022 "page-view.c"
	}
#line 980 "../src/page-view.vala"
	if (_tmp6_) {
#line 981 "../src/page-view.vala"
		return;
#line 4028 "page-view.c"
	}
#line 983 "../src/page-view.vala"
	self->priv->width_ = w;
#line 984 "../src/page-view.vala"
	self->priv->height_ = value;
#line 987 "../src/page-view.vala"
	self->priv->update_image = TRUE;
#line 989 "../src/page-view.vala"
	g_signal_emit (self, page_view_signals[PAGE_VIEW_SIZE_CHANGED_SIGNAL], 0);
#line 990 "../src/page-view.vala"
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
#line 976 "../src/page-view.vala"
	g_object_notify_by_pspec ((GObject *) self, page_view_properties[PAGE_VIEW_HEIGHT_PROPERTY]);
#line 4042 "page-view.c"
}

static void
page_view_class_init (PageViewClass * klass,
                      gpointer klass_data)
{
#line 26 "../src/page-view.vala"
	page_view_parent_class = g_type_class_peek_parent (klass);
#line 26 "../src/page-view.vala"
	g_type_class_adjust_private_offset (klass, &PageView_private_offset);
#line 26 "../src/page-view.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_page_view_get_property;
#line 26 "../src/page-view.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_page_view_set_property;
#line 26 "../src/page-view.vala"
	G_OBJECT_CLASS (klass)->finalize = page_view_finalize;
#line 26 "../src/page-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAGE_VIEW_PAGE_PROPERTY, page_view_properties[PAGE_VIEW_PAGE_PROPERTY] = g_param_spec_object ("page", "page", "page", TYPE_PAGE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../src/page-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAGE_VIEW_SELECTED_PROPERTY, page_view_properties[PAGE_VIEW_SELECTED_PROPERTY] = g_param_spec_boolean ("selected", "selected", "selected", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/page-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAGE_VIEW_X_OFFSET_PROPERTY, page_view_properties[PAGE_VIEW_X_OFFSET_PROPERTY] = g_param_spec_int ("x-offset", "x-offset", "x-offset", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/page-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAGE_VIEW_Y_OFFSET_PROPERTY, page_view_properties[PAGE_VIEW_Y_OFFSET_PROPERTY] = g_param_spec_int ("y-offset", "y-offset", "y-offset", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/page-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAGE_VIEW_CURSOR_PROPERTY, page_view_properties[PAGE_VIEW_CURSOR_PROPERTY] = g_param_spec_enum ("cursor", "cursor", "cursor", gdk_cursor_type_get_type (), GDK_ARROW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../src/page-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAGE_VIEW_WIDTH_PROPERTY, page_view_properties[PAGE_VIEW_WIDTH_PROPERTY] = g_param_spec_int ("width", "width", "width", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/page-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAGE_VIEW_HEIGHT_PROPERTY, page_view_properties[PAGE_VIEW_HEIGHT_PROPERTY] = g_param_spec_int ("height", "height", "height", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/page-view.vala"
	page_view_signals[PAGE_VIEW_SIZE_CHANGED_SIGNAL] = g_signal_new ("size-changed", TYPE_PAGE_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 26 "../src/page-view.vala"
	page_view_signals[PAGE_VIEW_CHANGED_SIGNAL] = g_signal_new ("changed", TYPE_PAGE_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 4077 "page-view.c"
}

static void
page_view_instance_init (PageView * self,
                         gpointer klass)
{
#line 26 "../src/page-view.vala"
	self->priv = page_view_get_instance_private (self);
#line 32 "../src/page-view.vala"
	self->priv->image = NULL;
#line 35 "../src/page-view.vala"
	self->priv->selected_ = FALSE;
#line 48 "../src/page-view.vala"
	self->priv->border_width = 1;
#line 51 "../src/page-view.vala"
	self->priv->update_image = TRUE;
#line 76 "../src/page-view.vala"
	self->priv->_cursor = GDK_ARROW;
#line 78 "../src/page-view.vala"
	self->priv->animate_n_segments = 7;
#line 4098 "page-view.c"
}

static void
page_view_finalize (GObject * obj)
{
	PageView * self;
	Page* _tmp0_;
	guint _tmp1_;
	Page* _tmp2_;
	guint _tmp3_;
	Page* _tmp4_;
	guint _tmp5_;
	Page* _tmp6_;
	guint _tmp7_;
	Page* _tmp8_;
	guint _tmp9_;
#line 26 "../src/page-view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PAGE_VIEW, PageView);
#line 97 "../src/page-view.vala"
	_tmp0_ = self->priv->_page;
#line 97 "../src/page-view.vala"
	g_signal_parse_name ("pixels-changed", TYPE_PAGE, &_tmp1_, NULL, FALSE);
#line 97 "../src/page-view.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _page_view_page_pixels_changed_cb_page_pixels_changed, self);
#line 98 "../src/page-view.vala"
	_tmp2_ = self->priv->_page;
#line 98 "../src/page-view.vala"
	g_signal_parse_name ("size-changed", TYPE_PAGE, &_tmp3_, NULL, FALSE);
#line 98 "../src/page-view.vala"
	g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _page_view_page_size_changed_cb_page_size_changed, self);
#line 99 "../src/page-view.vala"
	_tmp4_ = self->priv->_page;
#line 99 "../src/page-view.vala"
	g_signal_parse_name ("crop-changed", TYPE_PAGE, &_tmp5_, NULL, FALSE);
#line 99 "../src/page-view.vala"
	g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _page_view_page_overlay_changed_cb_page_crop_changed, self);
#line 100 "../src/page-view.vala"
	_tmp6_ = self->priv->_page;
#line 100 "../src/page-view.vala"
	g_signal_parse_name ("scan-line-changed", TYPE_PAGE, &_tmp7_, NULL, FALSE);
#line 100 "../src/page-view.vala"
	g_signal_handlers_disconnect_matched (_tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _page_view_page_overlay_changed_cb_page_scan_line_changed, self);
#line 101 "../src/page-view.vala"
	_tmp8_ = self->priv->_page;
#line 101 "../src/page-view.vala"
	g_signal_parse_name ("scan-direction-changed", TYPE_PAGE, &_tmp9_, NULL, FALSE);
#line 101 "../src/page-view.vala"
	g_signal_handlers_disconnect_matched (_tmp8_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp9_, 0, NULL, (GCallback) _page_view_scan_direction_changed_cb_page_scan_direction_changed, self);
#line 29 "../src/page-view.vala"
	_g_object_unref0 (self->priv->_page);
#line 32 "../src/page-view.vala"
	_g_object_unref0 (self->priv->image);
#line 26 "../src/page-view.vala"
	G_OBJECT_CLASS (page_view_parent_class)->finalize (obj);
#line 4153 "page-view.c"
}

GType
page_view_get_type (void)
{
	static volatile gsize page_view_type_id__volatile = 0;
	if (g_once_init_enter (&page_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PageViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) page_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PageView), 0, (GInstanceInitFunc) page_view_instance_init, NULL };
		GType page_view_type_id;
		page_view_type_id = g_type_register_static (G_TYPE_OBJECT, "PageView", &g_define_type_info, 0);
		PageView_private_offset = g_type_add_instance_private (page_view_type_id, sizeof (PageViewPrivate));
		g_once_init_leave (&page_view_type_id__volatile, page_view_type_id);
	}
	return page_view_type_id__volatile;
}

static void
_vala_page_view_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec)
{
	PageView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PAGE_VIEW, PageView);
#line 26 "../src/page-view.vala"
	switch (property_id) {
#line 26 "../src/page-view.vala"
		case PAGE_VIEW_PAGE_PROPERTY:
#line 26 "../src/page-view.vala"
		g_value_set_object (value, page_view_get_page (self));
#line 26 "../src/page-view.vala"
		break;
#line 26 "../src/page-view.vala"
		case PAGE_VIEW_SELECTED_PROPERTY:
#line 26 "../src/page-view.vala"
		g_value_set_boolean (value, page_view_get_selected (self));
#line 26 "../src/page-view.vala"
		break;
#line 26 "../src/page-view.vala"
		case PAGE_VIEW_X_OFFSET_PROPERTY:
#line 26 "../src/page-view.vala"
		g_value_set_int (value, page_view_get_x_offset (self));
#line 26 "../src/page-view.vala"
		break;
#line 26 "../src/page-view.vala"
		case PAGE_VIEW_Y_OFFSET_PROPERTY:
#line 26 "../src/page-view.vala"
		g_value_set_int (value, page_view_get_y_offset (self));
#line 26 "../src/page-view.vala"
		break;
#line 26 "../src/page-view.vala"
		case PAGE_VIEW_CURSOR_PROPERTY:
#line 26 "../src/page-view.vala"
		g_value_set_enum (value, page_view_get_cursor (self));
#line 26 "../src/page-view.vala"
		break;
#line 26 "../src/page-view.vala"
		case PAGE_VIEW_WIDTH_PROPERTY:
#line 26 "../src/page-view.vala"
		g_value_set_int (value, page_view_get_width (self));
#line 26 "../src/page-view.vala"
		break;
#line 26 "../src/page-view.vala"
		case PAGE_VIEW_HEIGHT_PROPERTY:
#line 26 "../src/page-view.vala"
		g_value_set_int (value, page_view_get_height (self));
#line 26 "../src/page-view.vala"
		break;
#line 4222 "page-view.c"
		default:
#line 26 "../src/page-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/page-view.vala"
		break;
#line 4228 "page-view.c"
	}
}

static void
_vala_page_view_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec)
{
	PageView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PAGE_VIEW, PageView);
#line 26 "../src/page-view.vala"
	switch (property_id) {
#line 26 "../src/page-view.vala"
		case PAGE_VIEW_PAGE_PROPERTY:
#line 26 "../src/page-view.vala"
		page_view_set_page (self, g_value_get_object (value));
#line 26 "../src/page-view.vala"
		break;
#line 26 "../src/page-view.vala"
		case PAGE_VIEW_SELECTED_PROPERTY:
#line 26 "../src/page-view.vala"
		page_view_set_selected (self, g_value_get_boolean (value));
#line 26 "../src/page-view.vala"
		break;
#line 26 "../src/page-view.vala"
		case PAGE_VIEW_X_OFFSET_PROPERTY:
#line 26 "../src/page-view.vala"
		page_view_set_x_offset (self, g_value_get_int (value));
#line 26 "../src/page-view.vala"
		break;
#line 26 "../src/page-view.vala"
		case PAGE_VIEW_Y_OFFSET_PROPERTY:
#line 26 "../src/page-view.vala"
		page_view_set_y_offset (self, g_value_get_int (value));
#line 26 "../src/page-view.vala"
		break;
#line 26 "../src/page-view.vala"
		case PAGE_VIEW_CURSOR_PROPERTY:
#line 26 "../src/page-view.vala"
		page_view_set_cursor (self, g_value_get_enum (value));
#line 26 "../src/page-view.vala"
		break;
#line 26 "../src/page-view.vala"
		case PAGE_VIEW_WIDTH_PROPERTY:
#line 26 "../src/page-view.vala"
		page_view_set_width (self, g_value_get_int (value));
#line 26 "../src/page-view.vala"
		break;
#line 26 "../src/page-view.vala"
		case PAGE_VIEW_HEIGHT_PROPERTY:
#line 26 "../src/page-view.vala"
		page_view_set_height (self, g_value_get_int (value));
#line 26 "../src/page-view.vala"
		break;
#line 4284 "page-view.c"
		default:
#line 26 "../src/page-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/page-view.vala"
		break;
#line 4290 "page-view.c"
	}
}

